// -----------------------------------------------------------------
//   Put alternating particles into A3 or D3
//	  Used in LMAIN
//	  Calls PINSERT
//
//   The CUDA/C++ code is based on the Fortran code from v8.06
// -----------------------------------------------------------------
#include "a3d3_gpu.h"
#include "pinsert_gpu.h"


extern pthread_key_t cuMemKey;

extern "C" void a3d3_(int *nset, int *iswitch, int *nsam, 
	int *irad, float *ri, float *rrec, float *amagp, CPLX *datc, 
	CPLX *datq, CPLX *ctff, CPLX *ctfs, float *asum, float *vsum, 
	float *psum, CPLX *c3df, int *ksum, float *phi, float *theta, 
	float *psi, float *dshx, float *dshy, float *presa, float *pbc, float *   //int * pbc -- data type wrong
	boff, CPLX *a3df, CPLX *a3ds, float *s3df, float *s3ds, 
	double *std, CPLX *d3df, CPLX *d3ds, float *v3df, float *v3ds,
	 double *vtd, int *nn1, int *maxset, float *sinclut, 
	int *irada, int *ipad, float *thetatr, int *iewald, 
	CPLX *c3ds, float *sumprel, int *nprel, int *nsym, int *
	isym, int *jsym, float *symop, int *nnstat, long *nksum, 
	int *ifsc, int *imp)
{ 
	//get Globla Variable GM
	cuMem *pGM=(cuMem *)pthread_getspecific(cuMemKey);
	
	int temp=1;
	float temp1;
	//	timeval begin,end;
//	gettimeofday(&begin,NULL);

//cudaMemset(pGM->d_std,0,sizeof(double)*(*nsam+1)*(*nsam+1));
//cudaMemset(pGM->d_vtd,0,sizeof(double)*(*nsam+1)*(*nsam+1));
//cudaMemset(pGM->d_nksum,0,sizeof(long)*(*nsam+1)*(*nsam+1));



	if(*iswitch==0)
	{
		temp1=*thetatr/(*amagp);
		pinsert(*nsam, *irad, *ri, (rrec[*nset-1]), *amagp, datc, datq, ctff, ctfs, 
				(CPLX *)pGM->d_a3df, (CPLX *)pGM->d_a3ds, pGM->d_s3df, pGM->d_s3ds, 
				(CPLX *)pGM->d_a3df, (CPLX *)pGM->d_a3ds, pGM->d_s3df, pGM->d_s3ds,	
				pGM->d_std, *phi, *theta, *psi, *dshx, *dshy, *presa, *pbc, *boff, 
				pGM->d_asum, pGM->d_vsum, pGM->d_psum, (CPLX *)pGM->d_c3df, pGM->d_ksum, 
				temp, sinclut, *irada, *ipad,	temp1, *iewald, (CPLX *)pGM->d_c3ds, 
				pGM->d_sumprel, pGM->d_nprel, 
				*nsym, isym, jsym, symop, *nnstat, pGM->d_nksum, *imp,pGM);
		if(*ifsc<=2) *iswitch=1;
	}
	else
	{
		if(*ifsc==0)
			{
				temp1=*thetatr/(*amagp);
				pinsert(*nsam, *irad, *ri, (rrec[*nset-1]), *amagp, datc, datq, ctff, ctfs, 
				 (CPLX *)pGM->d_d3df, (CPLX *)pGM->d_d3ds, pGM->d_v3df, pGM->d_v3ds, 
				 (CPLX *)pGM->d_d3df, (CPLX *)pGM->d_d3ds, pGM->d_v3df, pGM->d_v3ds, 
				 pGM->d_vtd, *phi, *theta, *psi, *dshx, *dshy, *presa, *pbc, *boff, 
				 pGM->d_asum, pGM->d_vsum, pGM->d_psum, (CPLX *)pGM->d_c3df, pGM->d_ksum, 
				 temp, sinclut, *irada, *ipad,	temp1, *iewald, (CPLX *)pGM->d_c3ds, 
				 pGM->d_sumprel, pGM->d_nprel,
				 *nsym, isym, jsym, symop, *nnstat, pGM->d_nksum, *imp, pGM);
				*iswitch=0;
			}
	}
	//	gettimeofday(&end,NULL);
	//	cout<<" A3D3 time is "<<CalTime(begin,end)<<endl;

}
