C**************************************************************************
        SUBROUTINE CARD10(NANG,IFLAG,FINPAR,NNPART,ILIST,PSI,THETA,PHI,
     +                 SHX,SHY,FILM,DFMID1,DFMID2,ANGAST,PRESA,
     +                 AMEANPHAS,NPHAS,NSAM,AMAGP,NSET,PSIZE,
     +		       MAXSET,RELMAG,NSS,IFIRST,ILAST,NNSET,NSETST,
     +                 DSTEP,TNSET,FSCT,THRESH,CMIN,CMAX,XM,YM,SX,SY)
C**************************************************************************
C Read input card 10 
C   - at least one of the following is required
C  Card 10a     FINPAR - INPUT PARAMETER FILE, required if mode key=0,1,2,3,4
C  Card 10b     NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,MORE if mode<0
C                 number of particles, magnification, film number, defocus
C                 parameters for this dataset.  If MORE='1', then more cards
C                 of this type follow, until MORE=0 terminates the parameter
C                 data.  The information on these cards is used to create a
C                 new parameter file.
C Called by Frealign.
C*************************************************************************
        IMPLICIT NONE
        REAL PI
	PARAMETER  (PI=3.1415926535897)
      	INTEGER NANG,NANG1,NANG2,IFLAG,NNPART,MAXSET
        INTEGER FILM(*),ILIST(*),TNSET(*),I
        INTEGER NNSET(*),NSAM,NSET,NPHAS,NIN,J,JN,IFIRST
        INTEGER NSS,NFILMS,NSETST,ILAST,IMORE,IFILMIN
        REAL PSIZE,DFMID1IN,DFMID2IN,ANGASTIN,ABSMAGPIN
        REAL PSI(*),THETA(*),PHI(*),DFMID1(*),FSCT(*)
        REAL DFMID2(*),ANGAST(*),SHX(*),SHY(*),THRESH(*)
        REAL PRESA(*),ABSMAGP,AMAGP(*)
        REAL DSTEP(*),RELMAG(*),AMEANPHAS
        REAL CMIN(*),CMAX(*),XM(*),YM(*),SX(*),SY(*)
	CHARACTER*200 FINPAR
	CHARACTER*200 LINE
        LOGICAL FOLD
C*************************************************************************
        FOLD=.FALSE.
	NANG1=NANG
      	NFILMS=0
        CMAX(NSET)=0.0
        XM(NSET)=0.0
        YM(NSET)=0.0
        SX(NSET)=0.0
        SY(NSET)=0.0
      	IF(IFLAG.GE.0) THEN		
C				! needs input parameter file
                CMIN(NSET)=999.0
      		WRITE(*,*)' INPUT PARAMETER FILE ?'
      		READ(*,7006)FINPAR
      		WRITE(*,17006)FINPAR
7006		FORMAT(A200)
17006		FORMAT(3X,A200)
CTSH		OPEN(77,FILE=FINPAR,STATUS='OLD',READONLY)
CTSH++
                OPEN(77,FILE=FINPAR,STATUS='OLD')
CTSH--
7009    	CONTINUE
      		READ(77,7007,END=7008)LINE
7007		FORMAT(A200)
                IF (LINE(1:1).EQ.'C') GOTO 7009
C      		IF (LINE(1:1).EQ.'C') THEN
C                  IF ((NSET.NE.1).OR.(IFLAG.EQ.0)) GOTO 7009
C                  DO 10 J=1,200-2
C                    IF (LINE(J:J+2).EQ.'FSC') GOTO 20
C10                CONTINUE
C                  GOTO 7009
C20                CONTINUE
C              WRITE(*,*)' Reading FSC Table from previous par file...'
C                  FSCT(1)=1.0
C                  DO 30 I=2,NSAM/2
C                    READ(77,7012,ERR=7013)J,FSCT(I)
C7012                FORMAT(1X,I4,24X,F7.3)
C                    IF (J.NE.I) GOTO 7013
C                    WRITE(*,7014)I,PSIZE*NSAM/REAL(I-1),FSCT(I)
C7014                FORMAT( 'IRAD, RESOL, FSC = ',I6,F7.1,F7.3)
C30                CONTINUE
C7013              CONTINUE
C                  GOTO 7009
C                ENDIF
		NANG=NANG+1
		IF (NANG.GT.NNPART)  THEN
	    		WRITE(*,*) '  Too many images, increase NNPART'
	    		STOP
		ENDIF
                IF (FOLD) THEN
      		  READ(LINE,7015)ILIST(NANG),PSI(NANG),THETA(NANG),
     +			PHI(NANG),SHX(NANG),SHY(NANG),ABSMAGP,FILM(NANG),
     +			DFMID1(NANG),DFMID2(NANG),ANGAST(NANG),PRESA(NANG)
7015              FORMAT(I7,5F8.3,F8.0,I6,2F9.1,F8.2,F7.2)
                ELSE
      		  READ(LINE,7011,ERR=99)ILIST(NANG),PSI(NANG),THETA(NANG),
     +			PHI(NANG),SHX(NANG),SHY(NANG),ABSMAGP,FILM(NANG),
     +			DFMID1(NANG),DFMID2(NANG),ANGAST(NANG),PRESA(NANG)
7011              FORMAT(I7,5F8.2,F8.0,I6,2F9.1,F8.2,F7.2)
                  GOTO 98
99                CONTINUE
                  WRITE(*,*) 'Error reading par file. ',
     +                       'Trying old par file format...'
                  FOLD=.TRUE.
98                CONTINUE
                ENDIF
      		IF(ILIST(NANG).LE.0) THEN
      		  NANG=NANG-1
      		  WRITE(*,*) ' ***WARNING*** blank line in parameter file'
      		  GO TO 7009
      		ENDIF
                IF((NANG.NE.NANG1+1).AND.
     +            (ABS(ILIST(NANG))-ABS(ILIST(NANG-1)).NE.1))
     +            WRITE(*,*) ' ***WARNING*** parameters missing for',
     +                       ' particle',ABS(ILIST(NANG))-1
		ILIST(NANG)=ILIST(NANG)*NSS
      		IF (PSI(NANG).GT.180.0) PSI(NANG)=PSI(NANG)-360.0
      		IF (THETA(NANG).GT.180.0) THETA(NANG)=THETA(NANG)-360.0
      		IF (PHI(NANG).GT.180.0) PHI(NANG)=PHI(NANG)-360.0
      		IF (PSI(NANG).LT.-180.0) PSI(NANG)=PSI(NANG)+360.0
      		IF (THETA(NANG).LT.-180.0) THETA(NANG)=THETA(NANG)+360.0
      		IF (PHI(NANG).LT.-180.0) PHI(NANG)=PHI(NANG)+360.0
      		IF (PRESA(NANG).LT.180.0) THEN
      	  		AMEANPHAS=AMEANPHAS+PRESA(NANG)
      	  		NPHAS=NPHAS+1
      		ENDIF
      		PSI(NANG)=PSI(NANG)/180.0*PI
      		THETA(NANG)=THETA(NANG)/180.0*PI
      		PHI(NANG)=PHI(NANG)/180.0*PI
      		PRESA(NANG)=PRESA(NANG)/180.0*PI
      		SHX(NANG)=-SHX(NANG)/NSAM*PI*2.0
      		SHY(NANG)=-SHY(NANG)/NSAM*PI*2.0
                IF (CMIN(NSET).GT.PRESA(NANG)) CMIN(NSET)=PRESA(NANG)
                IF (CMAX(NSET).LT.PRESA(NANG)) CMAX(NSET)=PRESA(NANG)
                XM(NSET)=XM(NSET)+SHX(NANG)
                YM(NSET)=YM(NSET)+SHY(NANG)
                SX(NSET)=SX(NSET)+SHX(NANG)**2
                SY(NSET)=SY(NSET)+SHY(NANG)**2
C      		IF (IFLAG.GE.3) THEN
C      			PSI(NANG)=0.0
C      			THETA(NANG)=0.0
C      			PHI(NANG)=0.0
C      			SHX(NANG)=0.0
C      			SHY(NANG)=0.0
C      			PRESA(NANG)=0.0
C      		ENDIF
      		ANGAST(NANG)=ANGAST(NANG)/180.0*PI
      		AMAGP(NANG)=RELMAG(NSET)*DSTEP(NSET)*10000./
     .			(ABS(ABSMAGP)*PSIZE)
      		IF(NANG.EQ.NANG1+1) THEN
      		   IF(AMAGP(NANG).LT.0.65.OR.AMAGP(NANG).GT.1.5) THEN
      			WRITE(*,7018) AMAGP(NANG),ABSMAGP,
     .				RELMAG(NSET),PSIZE,DSTEP(NSET)
7018			FORMAT(/' ***WARNING*** particle magnification and',
     .			' densitometer step size'/18X,
     .			' incompatible with selected pixel size'/
     .			60X,' AMAGP     = ',F9.4/
     .			60X,' ABSMAGP   = ',F9.1/
     .			60X,' RELMAG    = ',F9.4/
     .			60X,' PSIZE     = ',F9.4/
     .			60X,' DSTEP     = ',F9.4/)
      		   ELSE
      			WRITE(*,7019) AMAGP(NANG),ABSMAGP,
     .			RELMAG(NSET),PSIZE,DSTEP(NSET)
7019			FORMAT(/' AMAGP     = ',F9.4/
     .				' ABSMAGP   = ',F9.1/
     .				' RELMAG    = ',F9.4/
     .				' PSIZE     = ',F9.4/
     .				' DSTEP     = ',F9.4/)
      		   ENDIF
      		ENDIF
		GOTO  7009
7008		CONTINUE
		CLOSE(77)
      	ELSEIF(IFLAG.LT.0) THEN		
                CMIN(NSET)=0.0
C				! create parameter file from scratch
      		FINPAR='    none                                          '
7022      		NANG2=NANG
      		READ(*,*)NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,IMORE
      			NFILMS=NFILMS+1
      		NANG=NANG+NIN
                IF (NANG.GT.NNPART)  THEN
                        WRITE(*,*) '  Too many images, increase NNPART'
                        STOP
                ENDIF
      		WRITE(*,7021)NIN,ABSMAGPIN,IFILMIN,DFMID1IN,DFMID2IN,ANGASTIN,
     .			IFLAG,IMORE
7021		FORMAT(' Parameters created for this set of particles'/
     .			'         number of particles ...........',I8/
     .			'         magnification .................',F10.1/
     .			'         film number ...................',I8/
     .			'         defocus 1 .....................',F10.1/
     .			'         defocus 2 .....................',F10.1/
     .			'         astigmatism angle..............',F10.1/
     .			'           IFLAG........................',I8/
     .			'           IMORE........................',I8)

      		DO 7020 J=1,NIN
      		      JN=NANG2+J
      			ILIST(JN)=JN*NSS
      			PSI(JN)=0.0
      			THETA(JN)=0.0
      			PHI(JN)=0.0
      			SHX(JN)=0.0
      			SHY(JN)=0.0
      			AMAGP(JN)=RELMAG(NSET)*DSTEP(NSET)*10000./(ABSMAGPIN*PSIZE)
      			IF(JN.EQ.1) THEN
      			   IF(AMAGP(JN).LT.0.65.OR.AMAGP(JN).GT.1.5) THEN
      				WRITE(*,7018) AMAGP(JN),ABSMAGPIN,
     .				RELMAG(NSET),PSIZE,DSTEP(NSET)
      			   ELSE
      				WRITE(*,7019) AMAGP(JN),ABSMAGPIN,
     .				RELMAG(NSET),PSIZE,DSTEP(NSET)
      			   ENDIF
      			ENDIF
      			FILM(JN)=IFILMIN
      			DFMID1(JN)=DFMID1IN
      			DFMID2(JN)=DFMID2IN
      			ANGAST(JN)=ANGASTIN/180.0*PI
      			PRESA(JN)=0.0
7020		CONTINUE
      		IF(IMORE.EQ.1) GOTO 7022
      	ENDIF
                TNSET(NSET)=NANG-NANG1
                XM(NSET)=XM(NSET)/TNSET(NSET)
                YM(NSET)=YM(NSET)/TNSET(NSET)
                SX(NSET)=SQRT(SX(NSET)/TNSET(NSET)-XM(NSET)**2)
                SY(NSET)=SQRT(SY(NSET)/TNSET(NSET)-YM(NSET)**2)
C
		IF(NFILMS.NE.0) WRITE(*,2001) NSET,TNSET(NSET),NFILMS,NANG
		IF(NFILMS.EQ.0) WRITE(*,2002) NSET,TNSET(NSET),NANG
2001		FORMAT(' Number of images in set',I3,' =',I8,' (on',
     .			 I3,' new films)',', total images so far =',I8)
2002		FORMAT(' Number of images in set',I3,' =',I5,
     .			 ', total images so far =',I6)
                IF ((SX(NSET).LT.1.0E-6).OR.(SY(NSET).LT.1.0E-6)) THEN
                  SX(NSET)=99999.0
                  SY(NSET)=99999.0
                  WRITE(*,2004)
2004              FORMAT(/' Average X,Y shifts undetermined.',
     .                    ' X,Y ditribution function not used.',/)
                ELSE
		  WRITE(*,2003),CMIN(NSET)*180.0/PI,CMAX(NSET)*180.0/PI,
     .                        -XM(NSET)*NSAM/PI/2.0,
     .                        -YM(NSET)*NSAM/PI/2.0,
     .                        SX(NSET)*NSAM/PI/2.0,
     .                        SY(NSET)*NSAM/PI/2.0
2003		  FORMAT(/' Min, max phase residual =',2F8.3,/,
     .                  ' Using X,Y distribution function:',/,
     .                  ' Average X,Y shifts      =',2F8.3,/,
     .                  ' Sigma X,Y shifts        =',2F8.3,/)
                ENDIF
C       	NANG - total number of images
C
        IF (THRESH(NSET).LE.1.0) CALL PINC(NSET,THRESH,PRESA,NANG1,NANG)
C
      		IF ((NANG.GE.IFIRST).AND.(NSETST.EQ.0)) THEN
      	  		NSETST=NSET
      	  		NNSET(NSET)=NANG-IFIRST+1
      	  		IF (NANG.GT.ILAST) NNSET(NSET)=ILAST-IFIRST+1
      		ELSEIF ((NANG1+1.GE.IFIRST).AND.(NANG.LE.ILAST)) THEN
      	  		NNSET(NSET)=NANG-NANG1
      		ELSEIF (NANG.GT.ILAST) THEN
      	  		NNSET(NSET)=ILAST-NANG1
      		ENDIF
                RETURN
		END
