#include "lmain.h"

#include "ctfapply_gpu.h"
#include "variance_gpu.h"
#include "a3d3_gpu.h"
#include "func.h"
#include "presb_gpu.h"
#include "lock.h"


extern pthread_key_t cuMemKey;
//##############FORTRAN##################
extern "C" void iopen_(char *, int *, char *, int *, int *, int *, char *, char *, 
				float *, char *);

extern "C" void iread_(int *, float *, int *);  
  
//#######################################

	
	    
void lmain_(int &k, logical &fdef, logical &fmag, int &inproj, char &cform, 
			float *data, float *rrec, int &nsam, CPLX *spec, float *shx, 
			float *shy, float *cs, float *rawbins, float *wl, float &wgh1, 
			float &wgh2, float *dfmid1, float *dfmid2, float *angast, CPLX *outc, 
			float *outd, float *amagp, float &rih, float &halfw, float &halfwc, 
			float &ri2, float &ri3, float &ri4, float *datd, CPLX *datc, 
			float *b3dv, float *phi, float *theta, float *psi, float &xstd, 
			int &iflag, int &irada, CPLX *c3df, CPLX *c3ds, float *rbins, 
			float *rbinn, int &nset, CPLX *noic, float *nois, float *presa, 
			float *sang, int &nsang, float *ccd, CPLX *ccc, int &iquadmax,
			
			int &ndoc1, int &ndoc2, int *mask, float *rbfac, float *rmax1, 
			float *rmax2, int &iran, float &psize, float *dstep, int *film, 
			int &nn1, int &nnpart, int &maxset, logical &fhist, int *ilist, 
			int &npb, int &itmax, float &damax, logical &asymstore, float *target, 
			int &iccount, int &iswitch, int &ipad, float &pall, int &iall, 
			int &irad, float &ri, CPLX *a3df, CPLX *a3ds, float *s3df, 
			float *s3ds, double &std, CPLX *d3df, CPLX *d3ds, int *ilst, 
			float *v3df, float *v3ds, double &vtd, float &pbc, float &boff, 
			logical &fflip, float *asum, float *vsum, float *psum, int *ksum, 
			float *thresh, int &nsamh,	int &jc, int &fflag, float &ccave,
			 			
			int &icmp, int &ifirst, int &ioproj, int &iewald, int &nscf, 
			char *sfile, int &nang, float &wgh, float &psis, float &thetas, 
			float &phis, float &dshxs, float &dshys, float &press, int &iexcl, 
			int &ibuf, int &icount, logical &fmatch, float &dfmid1s, float &dfmid2s, 
			float &angasts, float &absmags, int &nstart, char *finpat1, char *finpat2, 
			char *asym, char *vx, int &ilast, int *nnset, int &iang, 
			char *cdate, char *ctime, char *czone, int *dtval, logical &fastig, 
			float *sinclut, float *mbuf, float *pbuf, CPLX *ctff, CPLX *ctfs, 
			float *rbin, CPLX *ccbuf, CPLX *ccs, CPLX *datq, CPLX *outq, 
			CPLX *noiq, CPLX *speq, CPLX *pbuq, CPLX *qbuc, CPLX *qbuq, 
			
			int &istat, int *tnset, logical &fall, int *ic, double *vsn, 
			double *vn, double *vvsn, double *vvn, logical *cia, float *bf, 
			int *ns, int &na, float *fsct, float *sumprel, int *nprel, 
			float *tx, float *ty, float *testpar, int &ipmax, int &nsym, 
			int *isym, int *jsym, float *symop, int &nnstat, long &nksum, 
			float *xm, float *ym, float *sx, float *sy, int &ifsc, 
			int &imp, int &njob, int nGPU, MRC &imstack)
{

   int i;
   int n1, n2, n3;
   int id, ip;
   float pmin, pmax,dshx, dshy;
   float psize1;
   char *finpat;
   float thetatr;
   int ifirsts;

   char strold[3]={'O','L','D'};
   
   int tnum1,tnum2;
   float tfnum1;
   
   //control the screen output to prevent crash.
   bool iout=false;
   if(k%1000==0) iout=true;
	//iout=true;
   
//   timeval begin,end,begin0,end0,begin1,end1;
//   gettimeofday(&begin,NULL);

   ifirsts=abs(ilist[0]);
   finpat=finpat1+(nset-1)*200;
   
   char mrcname[200];
   


   if(k==nstart)
   {
	   	//iopen_(finpat,&inproj,&cform,&n1,&n2,&n3,"OLD",asym,&psize1,vx);
	   	
	   	for(i=199;i>=0;i--)
   		{
   			if(finpat[i]=='c' && finpat[i-1]=='r' && finpat[i-2]=='m') break;
   		}
   		memcpy(mrcname,finpat,i+1);
   		mrcname[i+1]='\0';
	   	imstack.close();
	   	printf("Open Image Stack: %s\n",mrcname);
	   	if(imstack.open(mrcname,"rb")==0)
	   	{
	   		printf("Failed to open: %s\n",mrcname);
	   		exit(0);
	   	}	   	
	   	n3=imstack.getNz();
	   	
	   	if(n3>tnset[nset-1])
	   	{
	   		printf(" ***WARNING*** no. of particles in stack\n");
				printf(" exceeds no. of lines in parameter file:\n");
				printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);
	   	}
	   	if(n3<tnset[nset-1])
	   	{
	   		printf(" ****ERROR**** no. of particles in stack\n");
	   		printf(" smaller than no. of lines in parameter file:\n");
	   		printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);

	   		puts("Fatal error");
	   		exit(0);
	   	}

   }
   
   if(k>nstart)
   {
	   	if( (float(ilist[k-1])*float(ilist[k-1-nGPU])) < 0.0 )   //?????
	   	{
	   		printf(" PARTICLES ABOVE THRESHOLD (NOT INCLUDED)\n");
	   		printf(" IN SET %3d: %10d",nset,iexcl);
	   		
	   		iexcl=0;
	   		nset++;
	   		ifirst=k;
	   		ifirsts=abs(ilist[k-1]);
	   		//iclose_(&inproj);
	   		finpat=finpat1+(nset-1)*200;
	   		//iopen_(finpat,&inproj,&cform,&n1,&n2,&n3,strold,asym,&psize1,vx);
	   		
	   		for(i=199;i>=0;i--)
   			{
   				if(finpat[i]=='c' && finpat[i-1]=='r' && finpat[i-2]=='m') break;
   			}
   			memcpy(mrcname,finpat,i+1);
   			mrcname[i+1]='\0';
	   		imstack.close();
	   		printf("Open Image Stack: %s\n",mrcname);
	   		if(imstack.open(mrcname,"rb")==0)
	   		{
	   			printf("Failed to open: %s\n",mrcname);
	   			exit(0);
	   		}	
	   		n3=imstack.getNz();
	   		
	   		if(n3>tnset[nset-1])
	   		{
	   			printf(" ***WARNING*** no. of particles in stack\n");
					printf(" exceeds no. of lines in parameter file:\n");
					printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);
	   		}
	   		if(n3<tnset[nset-1])
	   		{
	   			printf(" ****ERROR**** no. of particles in stack\n");
	   			printf(" smaller than no. of lines in parameter file:\n");
	   			printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);
	   			puts("Fatal error");
	   			exit(0);
	   		}
	  
	   	}
   }
   
   dshx=0.0;
   dshy=0.0;
   
   if(k==nstart || k==(nstart+1)|| k%1000==0 || k==ilast)
   {
		date_and_time__(cdate, ctime, czone, dtval);
		printf(" Time before particle%6d was %c%c:%c%c:%c%c\n",
				k, ctime[0],ctime[1],ctime[2],ctime[3],ctime[4],ctime[5]);
   }

   thetatr=wl[nset-1]/(psize*nsam);
   
   
   
   
   //criterion for inclusion depends on THRESH
   if((thresh[nset-1]<0.0 && presa[k-1]<PI) || thresh[nset-1]>=0.0)
   {
      //then need to read in particle images because they were not
      // already read in for defocus or magnification refinement
     /* ip=nsam*(abs(ilist[k-1])-ifirsts);
      //lock_();
      for(i=1;i<=nsam;i++)
      {
      	id=1+nsam*(i-1);
      	tnum1=i+ip;
      	iread_(&inproj,&data[id-1],&tnum1);
      }
      
      //unlock_();
      pmin=1.0e30;
      pmax=-1.0e30;
      for(i=1;i<=nsam*nsam;i++)
   	{
   		if(data[i-1]>pmax) pmax=data[i-1];
   		if(data[i-1]<pmin) pmin=data[i-1];
   	}

   	if(pmax==pmin)
   	{
   		printf(" ****ERROR**** blank image, N = %d\n",k);
   		printf("Fatal error\n");
   		exit(0);
   	}
   	if(pmax<=0.0 || pmin>=0.0)
   	{
   		printf(" ****ERROR**** particle not normalized, N = %d\n",k);
   		printf("Fatal error\n");
   		exit(0);
   	}*/
   	
   	      
      imstack.read2DIm(data,abs(ilist[k-1])-ifirsts);
   	
   	tnum1=1;
   	tnum2=1;	
   	rlft3_((CPLX *)data,speq,&nsam,&nsam,&tnum1,&tnum2);


   	tnum1=0;
   	ctfapply(&nsam, spec, speq, &shx[k-1], &shy[k-1], &cs[nset-1], 
   			&wl[nset-1], &wgh1, &wgh2, &dfmid1[k-1], &dfmid2[k-1], &angast[k-1], 
   			&thetatr, ctff, ctfs, outd, outc, outq, &amagp[k-1], &rih, &halfw, 
   			&ri2, &ri3, &ri4, datd, datc, datq, b3dv, &phi[k-1], &theta[k-1], 
   			&psi[k-1], mbuf, &xstd, &tnum1, &tx[nset-1], &ty[nset-1]);


   	//criterion for insertion depends on THRESH
   	if((iflag<=3 && presa[k-1]<=abs(thresh[nset-1])) || 
   	   (iflag==4 && presa[k-1]<PI))
   	{
   		//maxr1=int(nsam*rmax1[nset-1]*abs(amagp[k-1]));
   		//maxr2=int(nsam*rmax2[nset-1]*abs(amagp[k-1]));
   		//rbfact=rbfac[nset-1]/(4.0*pow(nsam*psize*amagp[k-1],2));
//   		gettimeofday(&begin0,NULL);
   		//Put alternating particles into A3 or D3 
   		if(iflag==0 && istat==1)
   		{
   			tfnum1=thetatr/amagp[k-1];
   			presb(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   					phi[k-1],theta[k-1],psi[k-1],dshx,dshy,rbin,
   					sinclut,ipad,bf,tfnum1,iewald,ctff,ctfs,
   					ri2,ri3,rih,halfw);
   					
   			for(i=1;i<=nsam;i++)
   			{
   				rawbins[i-1]+=rbin[i-1];
   			}
   		}
//   		gettimeofday(&end0,NULL);
//   		gettimeofday(&begin1,NULL);
   		if(fall)
   		{
   			if(istat==1)
   			{	
   				variance_(&nsam,spec,speq,&shx[k-1],&shy[k-1],&ri,
   						&bf[0],(CPLX *)&bf[0],(CPLX *)&bf[nsam*nsam],&bf[2*nsam*nsam],
   						(CPLX *)&bf[2*nsam*nsam],(CPLX *)&bf[3*nsam*nsam],ic,vsn,vn,
   						vvsn,vvn,&amagp[k-1],&bf[4*nsam*nsam],&na);  						
   			}
   			a3d3_(&nset,&iswitch,&nsam,&irad,&ri,rrec,
   					&amagp[k-1],datc,datq,ctff,ctfs,asum,vsum,psum,c3df,
   					ksum,&phi[k-1],&theta[k-1],&psi[k-1],&dshx,&dshy,&presa[k-1],&pbc,
   					&boff,a3df,a3ds,s3df,s3ds,&std,d3df,d3ds,v3df,v3ds,&vtd,
   					&nn1,&maxset,sinclut,&irada,&ipad,&thetatr,&iewald,c3ds,
   					sumprel,nprel,&nsym,isym,jsym,symop,&nnstat,&nksum,
   					&ifsc,&imp);	
   		}
//   		gettimeofday(&end1,NULL);
   		pall+=presa[k-1]; //sum of all presa
   		iall++;  //number of presa
   	}
   	else
   	{
   		//if(fall && iout) printf(" **** PROJECTION %6d ABOVE THRESHOLD NOT INCLUDED\n",k);
   		iexcl++; //number of particles excluded 
   	}
   	
   }
   else
   {
   	//if(iout) printf(" **** PROJECTION %6d ABOVE THRESHOLD NOT INCLUDED\n",k);
   	iexcl++; //number of particles excluded 
   }
   
//  gettimeofday(&end,NULL);
//  printf("%6d  %15d %15d  %15d\n",k,CalTime(begin,end),CalTime(begin0,end0),CalTime(begin1,end1));

   

   
   
   return;
}			
			
		
		
		
		
		 
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
			
			
