#include "lmain_parameters.h"


lmain_parameters::lmain_parameters()
{
	initial();
}

lmain_parameters::~lmain_parameters()
{
	//free();
}
void lmain_parameters::initial()
{
	m_setNew2DImage=false;
	m_NN1=256;
	m_DeviceNum=0;
	m_step=1;
	m_nthread=0;
	m_nGPU=0;
	
}

void lmain_parameters::setReconstructionNum(int n)
{
	m_nrec=n;
}

void lmain_parameters::setDevice(int n)
{
	m_DeviceNum=n;
}

void lmain_parameters::setThreadNum(int n, int nGPU)
{
	m_nthread=n;
	m_nGPU=nGPU;
}

void lmain_parameters::setStep(int n)
{
	m_step=n;
}

void lmain_parameters::setBlockSize(int x, int y)
{
	m_xBlockSize=x;
	m_yBlockSize=y;
}

int lmain_parameters::set_iswitch(int iswitch)
{
	int temp=m_iswitch;
	m_iswitch=iswitch;
	return temp;  // return the old value
}

int lmain_parameters::set_New2DImage() // particle image(speq,spec) and ctf(ctff, ctfs)
{
	if(m_setNew2DImage==true) return 1;
	m_setNew2DImage=true;
	float *temp;
	int *itemp;
	
	//used to save particle image
	m_data=new float[m_nsam*m_nsam];  // raw image
	m_spec=(CPLX *)m_data;
	m_speq=new CPLX[m_nsam];

	m_outd=new float[m_nsam*m_nsam];  // CTFAPPLY  image*ctf*shift
	m_outc=(CPLX *)m_outd;
	m_outq=new CPLX[m_nsam];

	m_datd=new float[m_nsam*m_nsam];  // CTFAPPLY  image*shift
	m_datc=(CPLX *)m_datd;
	m_datq=new CPLX[m_NN1];
	
	m_mbuf=new float[m_NPB*m_nsam*m_nsam];
	m_pbuf=new float[m_NPB*m_nsam*m_nsam];
	m_pbuq=new CPLX[m_NPB*m_nsam];
	m_bf=new float[20*m_nsam*m_nsam];  //change 5 to 18, maybe wrong in pad.f??
	
	m_qbuc=new CPLX[m_NPB*m_nsam/2*m_nsam];
	m_qbuq=new CPLX[m_NPB*m_nsam];
	
	//used to save ctf
	m_ctff=new CPLX[m_nsam*m_nsam];
	m_ctfs=new CPLX[m_nsam*2];
	
	//used to cc
	m_ccd=new float[m_nsam*m_nsam];
	m_ccc=(CPLX *)m_ccd;
	m_ccs=new CPLX[m_nsam];
	m_ccbuf=new CPLX[m_nsam*m_nsam/2];
	
	//some bins
	temp=m_rbins;
	m_rbins=new float[m_nsam*2];
	memcpy(m_rbins,temp,sizeof(float)*m_nsam*2);
	
	temp=m_rbinn;
	m_rbinn=new float[m_nsam*2];
	memcpy(m_rbinn,temp,sizeof(float)*m_nsam*2);
	
	temp=m_rawbins;
	m_rawbins=new float[m_nsam*2];
	memcpy(m_rawbins,temp,sizeof(float)*m_nsam*2);
	
	//others
	m_nois=new float[m_nsam*m_nsam];
	m_noic=(CPLX *)m_nois;
	
	m_testpar=new float[6*(200+1)];  //IPMAXX=200
	
	temp=m_symop;
	m_symop=new float[9*m_ISYMAX]; //ISYMAX=100
	memcpy(m_symop,temp,sizeof(float)*9*m_ISYMAX);
	
	itemp=m_isym;
	m_isym=new int[m_ISYMAX]; //ISYMAX=100
	memcpy(m_isym,itemp,sizeof(int)*m_ISYMAX);
	
	itemp=m_jsym;
	m_jsym=new int[m_ISYMAX]; //ISYMAX=100
	memcpy(m_jsym,itemp,sizeof(int)*m_ISYMAX);
	
	
	return 0;
}

void lmain_parameters::free()
{
	if(m_setNew2DImage)
	{
		delete [] m_data;
		delete [] m_speq;
		
		delete [] m_ctff;
		delete [] m_ctfs;
		
		delete [] m_outd;
		delete [] m_outq;
		
		delete [] m_datd;
		delete [] m_datq;
		
		delete [] m_ccd;
		delete [] m_ccs;
		delete [] m_ccbuf;
		
		delete [] m_mbuf;
		delete [] m_pbuf;
		delete [] m_pbuq;
		delete [] m_bf;
		
		delete [] m_qbuc;
		delete [] m_qbuq;
		
		delete [] m_rbins;
		delete [] m_rbinn;
		delete [] m_rawbins;
		
		delete [] m_nois;
		delete [] m_testpar;
		
		delete [] m_symop;
		
		m_setNew2DImage=false;
	}
}

void lmain_parameters::set(int kstart, int kend, PageLockedMem *plm, int IMPMAX,
			logical fdef, logical fmag, int inproj, char cform, float *data, 
			float *rrec, int nsam, CPLX *spec, float *shx, float *shy, float *cs, 
			float *rawbins, float *wl, float wgh1, float wgh2, float *dfmid1, float *dfmid2, 
			float *angast,	CPLX *outc,	float *outd, float *amagp, float rih, float HALFW, 
			float halfwc, float ri2,float ri3, float ri4,float *datd, CPLX *datc, float *b3dv, 
			float *phi, float *theta, float *psi, float xstd, int iflag, int irada, CPLX *c3df, 
			CPLX *c3ds, float *rbins, float *rbinn, int nset, CPLX *noic, float *nois, float *presa, 
			float *sang, int nsang, float *ccd, CPLX *ccc, int iquadmax, int NDOC1, int NDOC2, 
			int *mask, float *rbfac, float *rmax1, float *rmax2, int iran, float psize, 
			float *dstep, int *film, int NN1, int NNPART, int MAXSET, logical fhist, int *ilist, 
			int NPB, int itmax, float DAMAX, logical asymstore, float *target, int iccount, 
			int iswitch, int ipad, float pall, int iall, int irad, float ri, CPLX *a3df, 
			CPLX *a3ds, float *s3df, float *s3ds, double std, CPLX *d3df, CPLX *d3ds, int *ilst, 
			float *v3df, float *v3ds, double vtd, float pbc, float boff, logical fflip, 
			float *asum, float *vsum, float *psum, int *ksum, float *thresh, int nsamh, 
			int jc, int fflag, float ccave, int icmp, int ifirst, int ioproj, int iewald, 
			int NSCF, char *sfile, int nang, float wgh, float psis, float thetas, float phis, 
			float dshxs, float dshys, float press, int iexcl, int ibuf, int icount, 
			logical fmatch, float dfmid1s, float dfmid2s, float angasts, float absmags, 
			int nstart, char *finpat1, char *finpat2, char *asym, char *vx, int ilast, 
			int *nnset, int IANG, char *cdate, char *ctime, char *czone, int *dtval, 
			logical fastig, float *sinclut, float *mbuf, float *pbuf, CPLX *ctff, CPLX *ctfs, 
			float *rbin, CPLX *ccbuf, CPLX *ccs, CPLX *datq, CPLX *outq, CPLX *noiq, 
			CPLX *speq, CPLX *pbuq, CPLX *qbuc, CPLX *qbuq, int istat, int *tnset, logical fall, 
			int *ic, double *vsn, double *vn, double *vvsn, double *vvn, logical *ci, 
			float *bf, int *ns, int na, float *fsct, float *sumprel, int *nprel, float *tx, 
			float *ty, float *testpar, int ipmax, int nsym, int *isym, int *jsym, float *symop, 
			int NNSTAT, long nksum, float *xm, float *ym, float *sx, float *sy, int ifsc, 
			int imp, int ISYMAX)
{
	m_kstart=	kstart;
	m_kend=    kend;
	m_IMPMAX=	IMPMAX;
	m_plm=plm;
	
	m_fdef=	fdef;
	m_fmag=	fmag;
	m_inproj=	inproj;
	m_cform=	cform;
	m_data=	data;
	m_rrec=	rrec;
	m_nsam=	nsam;
	m_spec=	spec;
	m_shx=	shx;
	
	m_shy=	shy;
	m_cs=	cs;
	m_rawbins=	rawbins;
	m_wl=	wl;
	m_wgh1=	wgh1;
	m_wgh2=	wgh2;
	m_dfmid1=	dfmid1;
	m_dfmid2=	dfmid2;
	m_angast=	angast;
	m_outc=	outc;
	
	m_outd=	outd;
	m_amagp=	amagp;
	m_rih=	rih;
	m_HALFW=	HALFW;
	m_halfwc=	halfwc;
	m_ri2=	ri2;
	m_ri3=	ri3;
	m_ri4=	ri4;
	m_datd=	datd;
	m_datc=	datc;
	
	m_b3dv=	b3dv;
	m_phi=	phi;
	m_theta=	theta;
	m_psi=	psi;
	m_xstd=	xstd;
	m_iflag=	iflag;
	m_irada=	irada;
	m_c3df=	c3df;
	m_c3ds=	c3ds;
	m_rbins=	rbins;
	
	m_rbinn=	rbinn;
	m_nset=	nset;
	m_noic=	noic;
	m_nois=	nois;
	m_presa=	presa;
	m_sang=	sang;
	m_nsang=	nsang;
	m_ccd=	ccd;
	m_ccc=	ccc;
	m_iquadmax=	iquadmax;
	
	m_NDOC1=	NDOC1;
	m_NDOC2=	NDOC2;
	m_mask=	mask;
	m_rbfac=	rbfac;
	m_rmax1=	rmax1;
	m_rmax2=	rmax2;
	m_iran=	iran;
	m_psize=	psize;
	m_dstep=	dstep;
	m_film=	film;
	
	m_NN1=	NN1;
	m_NNPART=	NNPART;
	m_MAXSET=	MAXSET;
	m_fhist=	fhist;
	m_ilist=	ilist;
	m_NPB=	NPB;
	m_itmax=	itmax;
	m_DAMAX=	DAMAX;
	m_asymstore=	asymstore;
	m_target=	target;
	
	m_iccount=	iccount;
	m_iswitch=	iswitch;
	m_ipad=	ipad;
	m_pall=	pall;
	m_iall=	iall;
	m_irad=	irad;
	m_ri=	ri;
	m_a3df=	a3df;
	m_a3ds=	a3ds;
	m_s3df=	s3df;
	
	m_s3ds=	s3ds;
	m_std=	std;
	m_d3df=	d3df;
	m_d3ds=	d3ds;
	m_ilst=	ilst;
	m_v3df=	v3df;
	m_v3ds=	v3ds;
	m_vtd=	vtd;
	m_pbc=	pbc;
	m_boff=	boff;
	
	m_fflip=	fflip;
	m_asum=	asum;
	m_vsum=	vsum;
	m_psum=	psum;
	m_ksum=	ksum;
	m_thresh=	thresh;
	m_nsamh=	nsamh;
	m_jc=	jc;
	m_fflag=	fflag;
	m_ccave=	ccave;
	
	m_icmp=	icmp;
	m_ifirst=	ifirst;
	m_ioproj=	ioproj;
	m_iewald=	iewald;
	m_NSCF=	NSCF;
	m_sfile=	sfile;
	m_nang=	nang;
	m_wgh=	wgh;
	m_psis=	psis;
	m_thetas=	thetas;
	
	m_phis=	phis;
	m_dshxs=	dshxs;
	m_dshys=	dshys;
	m_press=	press;
	m_iexcl=	iexcl;
	m_ibuf=	ibuf;
	m_icount=	icount;
	m_fmatch=	fmatch;
	m_dfmid1s=	dfmid1s;
	m_dfmid2s=	dfmid2s;
	
	m_angasts=	angasts;
	m_absmags=	absmags;
	m_nstart=	nstart;
	m_finpat1=	finpat1;
	m_finpat2=	finpat2;
	m_asym=	asym;
	m_vx=	vx;
	m_ilast=	ilast;
	m_nnset=	nnset;
	m_IANG=	IANG;
	
	m_cdate=	cdate;
	m_ctime=	ctime;
	m_czone=	czone;
	m_dtval=	dtval;
	m_fastig=	fastig;
	m_sinclut=	sinclut;
	m_mbuf=	mbuf;
	m_pbuf=	pbuf;
	m_ctff=	ctff;
	m_ctfs=	ctfs;
	
	m_rbin=	rbin;
	m_ccbuf=	ccbuf;
	m_ccs=	ccs;
	m_datq=	datq;
	m_outq=	outq;
	m_noiq=	noiq;
	m_speq=	speq;
	m_pbuq=	pbuq;
	m_qbuc=	qbuc;
	m_qbuq=	qbuq;
	
	m_istat=	istat;
	m_tnset=	tnset;
	m_fall=	fall;
	m_ic=	ic;
	m_vsn=	vsn;
	m_vn=	vn;
	m_vvsn=	vvsn;
	m_vvn=	vvn;
	m_ci=	ci;
	m_bf=	bf;
	
	m_ns=	ns;
	m_na=	na;
	m_fsct=	fsct;
	m_sumprel=	sumprel;
	m_nprel=	nprel;
	m_tx=	tx;
	m_ty=	ty;
	m_testpar=	testpar;
	m_ipmax=	ipmax;
	m_nsym=	nsym;
	
	m_isym=	isym;
	m_jsym=	jsym;
	m_symop=	symop;
	m_NNSTAT=	NNSTAT;
	m_nksum=	nksum;
	m_xm=	xm;
	m_ym=	ym;
	m_sx=	sx;
	m_sy=	sy;
	m_ifsc=	ifsc;
	
	m_imp=	imp;
	m_ISYMAX=ISYMAX;

}
