#include "inc.h"
#include "func.h"


// -----------------------------------------------------------------------------
//  Translated from Fortran to C/C++ codes by Xueming Li @ ucsf 
// -----------------------------------------------------------------------------
//	  SHIFT VOLUME TO ORIGIN
//	  C3D     - 3D map I/O
//	  U3D     - 3D weights I/O
//         Used in CARD13AND14
// -----------------------------------------------------------------------------
extern "C" void shift_(int *pnsam, CPLX *c3df, CPLX *c3ds, int *pnn1)
{
	int nsam=*pnsam;
	int jc,nsamh,l,ll,m,mm,n,nn,id,is,isum;
	CPLX pshftr;
	pshftr.y=0.0f;
	
	nsamh=nsam/2;
	jc=nsamh+1;
	
	for(l=1;l<=jc;++l)
	{
		ll=l-1;
		for(m=1;m<=nsam;++m)
		{
			mm=m-1;
			if(mm>=jc) mm=mm-nsam;
			for(n=1;n<=nsam;++n)
			{
				nn=n-1;
				if(nn>=jc) nn=nn-nsam;
				
				isum=ll+mm+nn;
				pshftr.x=1.0f;
				if(isum%2!=0) pshftr.x=-1.0f;
				
				if(l!=jc)
				{
					id=l+nsamh*(m-1+nsam*(n-1));
					c3df[id-1]=cXc(c3df[id-1],pshftr);
				}
				else
				{
					is=m+nsam*(n-1);
					c3ds[is-1]=cXc(c3ds[is-1],pshftr);
				}
				
			}
		}
	}
	
}
