#include "ainterpo3ds_gpu.h"
#include "func.h"
#include "boxft_lut_gpu.h"

CPLX ainterpo3ds(int nsam, int irad, CPLX *a3df, CPLX *a3ds, 
               float &xx, float &yy, float &zz,float *sinclut, int &ipad)
{
	int ls,lt,ns,nt,ms,mt,jc;
	int l,m,n,ll,mm,nn,is,nsamh;
	long id;
	float x,y,z,arg[3],boxftv;
	CPLX samp;

	samp.x=samp.y=0.0f;
	jc=nsam/2+1;
	nsamh=nsam/2;
	x=ipad*xx;
	y=ipad*yy;
	z=ipad*zz;
	
	ls=int(x)-irad+1;
	if(x<0.0f) ls=ls-1;
	if(ls<(-jc)) ls=-jc+1;
	lt=int(x)+irad;
	if(x<0.0f) lt=lt-1;
	if(lt>=jc) lt=jc-1;
	
	ms=int(y)-irad+1;
	if(y<0.0f) ms=ms-1;
	if(ms<=(-jc)) ms=-jc+1;
	mt=int(y)+irad;
	if(y<0.0f) mt=mt-1;
	if(mt>=jc) mt=jc-1;
	
	ns=int(z)-irad+1;
	if(z<0.0f) ns=ns-1;
	if(ns<=(-jc)) ns=-jc+1;
	nt=int(z)+irad;
	if(z<0.0f) nt=nt-1;
	if(nt>=jc) nt=jc-1;
	
	for(l=ls;l<=lt;l++)
	{
		arg[0]=x-l;
		for(m=ms;m<=mt;m++)
		{
			arg[1]=y-m;
			for(n=ns;n<=nt;n++)
			{
				arg[2]=z-n;
				boxftv=boxft_lut(arg, sinclut);
				if(l>=0)
				{
					ll=l+1;
					mm=m+1;
					if(mm<1) mm=mm+nsam;
					nn=n+1;
					if(nn<1) nn=nn+nsam;
					if(ll!=jc)
					{						
						id=ll+nsamh*((mm-1)+nsam*(nn-1));
						samp=cPc(samp,cXr(a3df[id-1],boxftv));
					}
					else
					{
						is=mm+nsam*(nn-1);
						samp=cPc(samp,cXr(a3ds[is-1],boxftv));
					}
				}
				else
				{
					ll=-l+1;
					mm=-m+1;
					if(mm<1) mm=mm+nsam;
					nn=-n+1;
					if(nn<1) nn=nn+nsam;
					if(ll!=jc)
					{
						id=ll+nsamh*((mm-1)+nsam*(nn-1));
						samp=cPc(samp,conjg(cXr(a3df[id-1],boxftv)));
					}
					else
					{
						is=mm+nsam*(nn-1);
						samp=cPc(samp,conjg(cXr(a3ds[is-1],boxftv)));
					}
				}
				
			}
		}
	}
	
	return samp;
} 
