C**************************************************************************
	SUBROUTINE CARD1(VX,CFORM,IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,
     .			 FMATCH,FHIST,FBEAUT,FCREF,NN1,NNBIG,NNPART,
     .                   NNSTAT,IFSC,IMP)
C**************************************************************************
C Card 1: describes the overall program flow control logic cards
C         CFORM,IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,FMATCH,FHIST,FBEAUT
C Called by Frealign.
C*************************************************************************
        IMPLICIT NONE
        INTEGER IFLAG,IEWALD,NN1,NNBIG,NNPART,NNSTAT,IFSC,IMP
        CHARACTER*15 VX
	CHARACTER*1 CFORM
	CHARACTER*80 INLINE
        LOGICAL FMAG,FDEF,FFLIP,FMATCH,FHIST
        LOGICAL FASTIG,FBEAUT,FCREF
C*************************************************************************
        WRITE(*,7000) VX,NN1,NNBIG,NNPART,NNSTAT,IMP
7000    FORMAT(/' FREALIGN - Fourier REconstruction and ALIGNment',
     *         /' V',A15,
     *         /' Distributed under the GNU',
     *          ' General Public License (GPL)'/,
     *         /' Max. particle dimensions (NN1) = ',I8,
     *         /' Interpolation array (NNBIG) =    ',I8,
     *         /' Max. no. of particles (NNPART) = ',I8,
     *         /' Statistical arrays (NNSTAT) =    ',I8,
     *        //' Parallel processing ($NCPUS) =   ',I8,
     *         /' (parallel version only with PGI',
     *          ' compiler and -mp switch)',//)
C
        WRITE(*,*)' CFORM,IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,FMATCH,',
     *            'FHIST,FBEAUT,FCREF,IFSC?'
        READ(*,'(A)')INLINE
        CFORM=INLINE(1:1)
        READ(INLINE(3:),*,ERR=99)IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,
     .                      FMATCH,FHIST,FBEAUT,FCREF,IFSC
CTSH            READ(*,7001)CFORM,IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,
CTSH     .                      FMATCH,FHIST,FBEAUT
CTSH++
        GOTO 98
99      CONTINUE
        WRITE(*,*) 'CARD 1: Error. Trying old CARD 1 input...'
        READ(INLINE(3:),*,ERR=99)IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,
     .                      FMATCH,FHIST,FBEAUT
        FCREF=.FALSE.
        IFSC=0
98      CONTINUE
CTSH--
        WRITE(*,17001)CFORM,IFLAG,FMAG,FDEF,FASTIG,FFLIP,IEWALD,
     .                  FMATCH,FHIST,FBEAUT,FCREF,IFSC
CTSH7001        FORMAT(A1,1X,I,4L,I,4L)
17001   FORMAT(3X,A1,I3,4L2,I5,4L2,I3)
      	IF(FDEF.AND.IFLAG.LT.0) THEN
      	WRITE(*,*)'Cannot refine defocus without first determining',
     .	' particle parameters at least roughly'
      	STOP 'FDEF true therefore not allowed'
      	ENDIF
      	IF(FMAG.AND.IFLAG.LT.0) THEN
      		WRITE(*,6999)
6999		FORMAT('Cannot refine magnification of all particle',
     .		' images from same film'/' without first determining',
     .		' particle parameters at least roughly')
      		STOP 'FMAG true therefore not allowed'
        ENDIF
        IF(IFLAG.EQ.0.AND.FMAG)THEN
          WRITE(*,*) 'Cannot refine magnification with MODE=0;',
     +               ' FMAG set to F'
          FMAG=.FALSE.
        ENDIF
        IF(IFLAG.EQ.0.AND.FDEF)THEN
          WRITE(*,*) 'Cannot refine defocus with MODE=0;',
     +               ' FDEF set to F'
          FDEF=.FALSE.
        ENDIF
        IF(IFLAG.EQ.0.AND.FASTIG)THEN
          WRITE(*,*) 'Cannot refine astigmatism with MODE=0;',
     +               ' FASTIG set to F'
          FASTIG=.FALSE.
      	ENDIF
      	IF(FCREF.AND.(IFSC.NE.0)) THEN
      	WRITE(*,*)'Cannot apply FSC-weighting if IFSC not',
     .	' equal to 0'
      	STOP 'FCREF true therefore not allowed'
      	ENDIF
	RETURN
	END
