#include "ctfrefine_gpu.h"
#include "va04_gpu.h"

int ctfrefine(float *dfmid1, float *dfmid2, float* angast, 
	int ifirstf, int lastf, bool fastig, int np, 
	int nsam, int maxr1, int maxr2, int *mask, int nn1, 
	float &ddfmid1, float &ddfmid2, float &dangast, CPLX  *c3df, 
	CPLX  *c3ds, int irad, CPLX  *outq, int npb, float *pbuf,
	CPLX  *pbuq, float *shx, float *shy, int ipad, float cs, float wl, 
	float wgh1, float wgh2, float thetatr, CPLX  *ctff, CPLX  *ctfs, 
	float *amag, float rih, float halfw, float ri2, float ri3, float ri4, 
	float *phi, float *theta, float *psi, float rmax1, float rmax2, 
	float xstd, float *mbuf, int *ilst, CPLX  *datc, CPLX  *datq, 
	int ibuf, float *b3dv, float *datd, float *sinclut, int ivflag,
	float rbfact, float *outd, CPLX  *outc, CPLX  *qbuc, CPLX  *qbuq, 
	bool ci, float *rbuf, float *fsct, int *film, int ilast, 
	int iewald, float tx, float ty)
{
    

	float epar[6] = { 10.0f,10.0f,0.05f,0.0f,0.0f,0.0f };
	float escale = 100.0f;
	int ncycls=50;
	int i;
	if(!ci) printf("Entering CTFREFINE with range %10d %10d %4d\n",ifirstf,lastf,fastig);
	float xpar[3],presa;
	xpar[0] = 0.0f;
	xpar[1] = 0.0f;
	xpar[2] = 0.0f;
	float xp[6],sx,sy,sig2;
	int n;
	if(fastig) 
	{
		n=3;
		sx=0.0;
		sy=0.0;
		sig2=0.0;
		va04a(xpar, epar, n, presa, escale, 0, 1, ncycls, 
			xp, np, nsam, maxr1, maxr2, mask, nn1, c3df, c3ds, 
			irad, outq, npb, pbuf, pbuq, shx, shy, ipad, cs, wl, 
			wgh1, wgh2, thetatr, ctff, ctfs, amag, rih, halfw, ri2, ri3, ri4, 
			phi, theta, psi, rmax1, rmax2, xstd, mbuf, ilst, datc, datq, 
			ibuf, b3dv, datd, sinclut, ivflag, rbfact, outd, outc, qbuc, qbuq, 
			rbuf, fsct, dfmid1, dfmid2, angast, iewald, tx, ty, 0.0, 0.0, 
			sx, sy, sig2);
	}

	if(!fastig) 
	{
		n=1;
		sx=0.0;
		sy=0.0;
		sig2=0.0;
		va04a(xpar, epar, n, presa, escale, 0, 1, ncycls, 
			xp, np, nsam, maxr1, maxr2, mask, nn1, c3df, c3ds, 
			irad, outq, npb, pbuf, pbuq, shx, shy, ipad, cs, wl, 
			wgh1, wgh2, thetatr, ctff, ctfs, amag, rih, halfw, ri2, ri3, ri4, 
			phi, theta, psi, rmax1, rmax2, xstd, mbuf, ilst, datc, datq, 
			ibuf, b3dv, datd, sinclut, ivflag, rbfact, outd, outc, qbuc, qbuq, 
			rbuf, fsct, dfmid1, dfmid2, angast, iewald, tx, ty, 0.0, 0.0, 
			sx, sy, sig2);
	}
	if (!fastig) xpar[1] = xpar[0];

	if (!ci) 
	{
		for (i=ifirstf;i<=ilast;++i) 
		{
			if (film[ifirstf-1]==film[i-1]) 
			{
				dfmid1[i-1]+=xpar[0];
				dfmid2[i-1]+=xpar[1];
				angast[i-1]+=xpar[2];
			} 
			else 
			{
				break;
	    	}
		}
		printf("Exit from CTFREFINE, defocus change %9.1f %9.1f %8.2f\n", 
			xpar[0],xpar[1],xpar[2]*180.0/3.141592654);
	} 
	else 
	{
		dfmid1[0] += xpar[0];
		dfmid2[0] += xpar[1];
		angast[0] += xpar[2];
	}
   ddfmid1 = xpar[0];
   ddfmid2 = xpar[1];
   dangast = xpar[2];

	return 0;

}

