#include "ewaldex_gpu.h"
#include "func.h"
#include "ainterpo3dbig_gpu.h"
#include "ainterpo3ds_gpu.h"   

CPLX ewaldex(int &nsam, int &irad, CPLX *a3df, CPLX *a3ds, 
             float *sinclut, int &ipad,
             int &i, int &j,float *dm, float &thet, CPLX &ctfr, CPLX &ctfl)
{
	float x3,y3,z3;
	float thetah,gpix,x,y,z;
	CPLX ainpo1,ainpo2;
	
	gpix=sqrt(float(i*i+j*j));  //length of resol.vector g in pixel
	thetah=gpix*thet/2;       //THET=(WL/(PSIZE*NSAM))/AMAGP
	x=i*cos(thetah);          //THETAH=scattering angle/2.
	y=j*cos(thetah);
	z=gpix*sin(thetah);
	x3=dm[0]*x+dm[3]*y+dm[6]*z;
	y3=dm[1]*x+dm[4]*y+dm[7]*z;
	z3=dm[2]*x+dm[5]*y+dm[8]*z;
	
	if(irad==0) //AINPO1 is first beam
	{
		ainpo1=ainterpo3dbig(nsam,ipad,a3df,a3ds,x3,y3,z3);
	}
	else
	{
		ainpo1=ainterpo3ds(ipad*nsam,irad,a3df,a3ds,x3,y3,z3,sinclut,ipad);
	}
	
	x3=dm[0]*x+dm[3]*y-dm[6]*z;  //AINPO2 is second beam = conjg(x,y,-z)
	y3=dm[1]*x+dm[4]*y-dm[7]*z;
	z3=dm[2]*x+dm[5]*y-dm[8]*z;
	if(irad==0)
	{
		ainpo2=ainterpo3dbig(nsam,ipad,a3df,a3ds,x3,y3,z3);
	}
	else
	{
		ainpo2=ainterpo3ds(ipad*nsam,irad,a3df,a3ds,x3,y3,z3,sinclut,ipad);
	}
	return cPc(cXc(ainpo1,ctfr),cXc(ainpo2,conjg(ctfl)));  //combine beams
}
