#include "func.h"

__host__ CPLX conjg(CPLX f)
{
	f.y*=-1.0f;
	return f;
}

__host__ float cabs(CPLX f)
{
	return sqrt(f.x*f.x+f.y*f.y);
}

__host__ CPLX cXc(CPLX a, CPLX b) // a*b
{
	CPLX c;
	c.x=a.x*b.x-a.y*b.y;
	c.y=a.x*b.y+a.y*b.x;
	return c;
}

__host__ CPLX cDc(CPLX a, CPLX b) // a/b
{
	CPLX c;
	float ss=b.x*b.x+b.y*b.y;
	c.x=(a.x*b.x+a.y*b.y)/ss;
	c.y=(a.y*b.x-a.x*b.y)/ss;
	return c;
}

__host__ CPLX cXr(CPLX a, float b)
{
	CPLX c;
	c.x=a.x*b;
	c.y=a.y*b;
	return c;
}

__host__ CPLX cPc(CPLX a, CPLX b) //a+b
{
	CPLX c;
	c.x=a.x+b.x;
	c.y=a.y+b.y;
	return c;
}

__host__ CPLX cMc(CPLX a, CPLX b)  //a-b
{
	CPLX c;
	c.x=a.x-b.x;
	c.y=a.y-b.y;
	return c;
}

extern vector<list<string> > OPPar;
extern pthread_mutex_t mutex_oppar;

void outputpar(int njob, char *sline)
{
	sline[103]='\0';
	pthread_mutex_lock(&mutex_oppar);
	OPPar[njob].push_back(sline);
	pthread_mutex_unlock(&mutex_oppar);
}


void safecall(cudaError_t call, const char* fname) 
{
	if (call != cudaSuccess)
	{
		printf("Call to '%s' in thread(%ld)returned '%s'\n", fname,pthread_self(),cudaGetErrorString(call));
		exit(0);
	}
}

void checkerror(const char *fname)
{
	safecall(cudaGetLastError(),fname);
}

void datatofile(void *data, size_t sizeinbyte, char *filename)
{
	FILE *fp=fopen(filename,"wb");
	fwrite(data,sizeinbyte,1,fp);
	fclose(fp);
}

                      
