#include "lmain.h"

#include "ctfapply_gpu.h"
#include "sigma2_gpu.h"
#include "variance_gpu.h"
#include "a3d3_gpu.h"
#include "func.h"
#include "prefine_gpu.h"
#include "cc3m_gpu.h"
#include "fsh_gpu.h"
#include "psearch_gpu.h"
#include "lock.h"
#include "ccoef_gpu.h"
#include "presb_gpu.h"
#include "ctfrefine_gpu.h"
#include "magrefine_gpu.h"


extern pthread_key_t cuMemKey;
//##############FORTRAN##################
extern "C" void iopen_(char *, int *, char *, int *, int *, int *, char *, char *, 
				float *, char *);

extern "C" void iread_(int *, float *, int *);

/*extern "C" void magrefine_(float *, float *, float *, float *, 
	    int *, int *, int *, int *, int *, int *, 
	    int *, int *, CPLX *, CPLX *, int *, CPLX *, 
	    int *, float *, CPLX *, float *, float *, int *, float *, 
	    float *, float *, float *, float *, CPLX *, CPLX *, float *, 
	    float *, float *, float *, float *, float *, float *, float *, float *, 
	    float *, float *, float *, float *, int *, CPLX *, CPLX *, 
	    int *, float *, float *, float *, int *, float *, float *, 
	    CPLX *, CPLX *, CPLX *, float *, float *, int *, 
	    int *, int *, float *, float *);
	    
extern "C" void ctfrefine_(float *dfmid1, float *dfmid2, float *angast, 
		int *ifirstf, int *lastf, logical *fastig, int *np, 
		int *nsam, int *maxr1, int *maxr2, int *mask, int 
		*nn1, float *ddfmid1, float *ddfmid2, float *dangast, CPLX *c3df, 
		CPLX *c3ds, int *irad, CPLX *outq, int *npb, CPLX *pbuf,
	 	CPLX *pbuq, float *shx, float *shy, int *ipad, float *cs, float *
		wl, float *wgh1, float *wgh2, float *thetatr, CPLX *ctff, CPLX *
		ctfs, float *amag, float *rih, float *halfw, float *ri2, float *ri3, float *
		ri4, float *phi, float *theta, float *psi, float *rmax1, float *rmax2, 
		float *xstd, float *mbuf, int *ilst, CPLX *datc, CPLX *datq, 
		int *ibuf, float *b3dv, float *datd, float *sinclut, int *ivflag,
	 	float *rbfact, float *outd, CPLX *outc, CPLX *qbuc, CPLX *
		qbuq, logical *ci, float *rbuf, float *fsct, int *film, int *
		ilast, int *iewald, float *tx, float *ty);   
		
extern "C" void presb_(int *nsam, int *irad, float *amag, CPLX 
		*spec, CPLX *speq, CPLX *a3df, CPLX *a3ds, int *maxr1, 
		int *maxr2, float *phi, float *theta, float *psi, float *shx, float *
		shy, float *rbin, float *sinclut, int *ipad, int *ns, float *
		bufa, float *bufb, float *bufab, float *cs, float *wl, float *wgh1, float *
		wgh2, float *df1, float *df2, float *angast, float *thet, int *iewald,
		CPLX *ctff, CPLX *ctfs, float *ri2, float *ri3, float *rih, float *
		halfw);*/
		
extern "C" void match_(int *k, int *nsam, int *irada, CPLX *outc, float *outd, 
		CPLX *outq, CPLX *c3df, CPLX *c3ds, float *phi, float *theta, 
		float *psi, int *jc, int *nsamh, float *phase, float *shx, 
		float *shy, float *dshx, float *dshy, int *nn1, float *xstd, 
		float *ri, float *b3dv, float *mbuf, int *icmp, float *data, 
		CPLX *speq, float *ccpart, float *presa, float *presaold, float *thresh, 
		char *cform, int *maxset, int *npb, int *ilist, int *ifirst, 
		int *nset, int *ioproj, float *sinclut, int *ipad, float *thetatr, 
		int *iewald, CPLX *ctff, CPLX *ctfs);

	    
//extern "C" void ccoef_(float *,int *, int *, float *, CPLX *, CPLX 
//	    *, CPLX *, CPLX *, float *, float *, float *, float *, float *, 
//	    float *, int *, int *, float *, CPLX *, CPLX *, float *);

extern "C" float 	crandom_(float *result,int *is);    
//#######################################

float random(int &is)
{
	float result;
	crandom_(&result,&is);
	return result;
}	
	    
void lmain_(int &k, logical &fdef, logical &fmag, int &inproj, char &cform, 
			float *data, float *rrec, int &nsam, CPLX *spec, float *shx, 
			float *shy, float *cs, float *rawbins, float *wl, float &wgh1, 
			float &wgh2, float *dfmid1, float *dfmid2, float *angast, CPLX *outc, 
			float *outd, float *amagp, float &rih, float &halfw, float &halfwc, 
			float &ri2, float &ri3, float &ri4, float *datd, CPLX *datc, 
			float *b3dv, float *phi, float *theta, float *psi, float &xstd, 
			int &iflag, int &irada, CPLX *c3df, CPLX *c3ds, float *rbins, 
			float *rbinn, int &nset, CPLX *noic, float *nois, float *presa, 
			float *sang, int &nsang, float *ccd, CPLX *ccc, int &iquadmax,
			
			int &ndoc1, int &ndoc2, int *mask, float *rbfac, float *rmax1, 
			float *rmax2, int &iran, float &psize, float *dstep, int *film, 
			int &nn1, int &nnpart, int &maxset, logical &fhist, int *ilist, 
			int &npb, int &itmax, float &damax, logical &asymstore, float *target, 
			int &iccount, int &iswitch, int &ipad, float &pall, int &iall, 
			int &irad, float &ri, CPLX *a3df, CPLX *a3ds, float *s3df, 
			float *s3ds, double &std, CPLX *d3df, CPLX *d3ds, int *ilst, 
			float *v3df, float *v3ds, double &vtd, float &pbc, float &boff, 
			logical &fflip, float *asum, float *vsum, float *psum, int *ksum, 
			float *thresh, int &nsamh,	int &jc, int &fflag, float &ccave,
			 			
			int &icmp, int &ifirst, int &ioproj, int &iewald, int &nscf, 
			char *sfile, int &nang, float &wgh, float &psis, float &thetas, 
			float &phis, float &dshxs, float &dshys, float &press, int &iexcl, 
			int &ibuf, int &icount, logical &fmatch, float &dfmid1s, float &dfmid2s, 
			float &angasts, float &absmags, int &nstart, char *finpat1, char *finpat2, 
			char *asym, char *vx, int &ilast, int *nnset, int &iang, 
			char *cdate, char *ctime, char *czone, int *dtval, logical &fastig, 
			float *sinclut, float *mbuf, float *pbuf, CPLX *ctff, CPLX *ctfs, 
			float *rbin, CPLX *ccbuf, CPLX *ccs, CPLX *datq, CPLX *outq, 
			CPLX *noiq, CPLX *speq, CPLX *pbuq, CPLX *qbuc, CPLX *qbuq, 
			
			int &istat, int *tnset, logical &fall, int *ic, double *vsn, 
			double *vn, double *vvsn, double *vvn, logical *cia, float *bf, 
			int *ns, int &na, float *fsct, float *sumprel, int *nprel, 
			float *tx, float *ty, float *testpar, int &ipmax, int &nsym, 
			int *isym, int *jsym, float *symop, int &nnstat, long &nksum, 
			float *xm, float *ym, float *sx, float *sy, int &ifsc, 
			int &imp, int &njob, FILE *fp, MRC &imstack)
{
	float presmin2, bestamag;
	float thetaold, presaold;
	float bestdshx, bestdshy;
   int i, j;
   int n1, n2, n3;
   float besttheta, bestdfmid1, bestdfmid2;
   logical ci;
   int id, jj, is, ip;
   float bestangast;
   int itf;
   float csn;
   int itt;
   float wln;
   float sig2;
   int npar;
   float pmin, pmax, dpsi, dphi, phim, psim, dshx, dshy;
   float phim2;
   int maxr1, maxr2;
   float psim2;
   int ibufb;
   float amagm;
   int lastf;
   float presn, bestp, amagm2, dshxm, dshym;
   float phase;
   float dshxm2, dshym2, rmax1n, rmax2n, psize1, rbfact;
   int ivflag;
   float dtheta, ccpart, phiold;
   char *finpat;
   float thetam;
   float psiold;
   int maxres;
   float ddfmid1, ddfmid2, thetam2, amagold, dangast;
   float bestphi;
   int ifirstf;
   float bestpsi, thetatr, presmin;
   int ifirsts;
   float dsmax=4.0;
   
   int tempint,strlen;
   char outputparline[108];
   char strnew[3]={'N','E','W'};
   char strold[3]={'O','L','D'};
   
   char mrcname[200];
   
   int tnum1,tnum2;
   float tfnum1;
   
   //control the screen output to prevent crash.
   bool iout=false;
   if(k%1000==0) iout=true;
	//iout=true;

//   timeval begin,end,begin0,end0;
//   gettimeofday(&begin0,NULL);
 	ifirstf=1;
   for(j=k;j>=2;j--)
   {
   	if(film[j-1]!=film[j-2])
   	{
   		ifirstf=j;
   		if(j==k) ibuf=0;
   		break;
   	}
   }

   
   ifirsts=abs(ilist[0]);
   ccpart=0.0f;
   finpat=finpat1+(nset-1)*200;
   rbfact=rbfac[nset-1]/(4.0*pow((nsam*psize*amagp[k-1]),2));
   ci=cia[nset-1];

   if(k==nstart)
   {
   	//iopen_(finpat,&inproj,&cform,&n1,&n2,&n3,"OLD",asym,&psize1,vx);
   	
   	for(i=199;i>=0;i--)
   	{
   		if(finpat[i]=='c' && finpat[i-1]=='r' && finpat[i-2]=='m') break;
   	}
   	memcpy(mrcname,finpat,i+1);
   	mrcname[i+1]='\0';
	   imstack.close();
	   printf("\nOpen Image Stack: %s\n",mrcname);
	   if(imstack.open(mrcname,"rb")==0)
	   {
	   	printf("Failed to open: %s\n",mrcname);
	   	exit(0);
	   }	   	
	   n3=imstack.getNz();
   	
   	
   	if(n3>tnset[nset-1])
   	{
   		printf(" ***WARNING*** no. of particles in stack\n");
			printf(" exceeds no. of lines in parameter file:\n");
			printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);
   	}
   	if(n3<tnset[nset-1])
   	{
   		printf(" ****ERROR**** no. of particles in stack\n");
   		printf(" smaller than no. of lines in parameter file:\n");
   		printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);

   		puts("Fatal error");
   		exit(0);
   	}
   	
   	if(fmatch)
   	{
   		n1=int(3.0*ri/icmp);
   		if((n1*icmp)>nsam) n1=nsam/icmp;
   		n2=n1;
   		n3=nnset[nset-1];
   		tnum1=2*n1;
   		iopen_(finpat2+(nset-1)*200,&ioproj,&cform,&n1,
   				&tnum1,&n3,strnew,asym,&psize,vx);
   	}
   	
   	if(njob==0)
   	{     	
			strlen=102;			
			tempint=ndoc1+nset;
			sprintf(outputparline,"C           PSI   THETA     PHI     SHX     SHY    MAG   FILM      DF1      DF2  ANGAST  PRESA   DPRES");
			strtofile_(&tempint,outputparline,&strlen);
	 	
	 		strlen=94;
			tempint=ndoc2+nset;
			sprintf(outputparline,"C           PSI   THETA     PHI     SHX     SHY    MAG   FILM      DF1      DF2  ANGAST  PRESA");
			strtofile_(&tempint,outputparline,&strlen);
		}
   }
   
   if(k>nstart)
   {
   	if( (float(ilist[k-1])*float(ilist[k-2])) < 0.0 )   //?????
   	{
   		printf(" PARTICLES ABOVE THRESHOLD (NOT INCLUDED)\n");
   		printf(" IN SET %3d: %10d",nset,iexcl);
   		
   		iexcl=0;
   		nset++;
   		ifirst=k;
   		ifirsts=abs(ilist[k-1]);
   		//iclose_(&inproj);
   		finpat=finpat1+(nset-1)*200;
   		//iopen_(finpat,&inproj,&cform,&n1,&n2,&n3,strold,asym,&psize1,vx);
   		
   		for(i=199;i>=0;i--)
   		{
   			if(finpat[i]=='c' && finpat[i-1]=='r' && finpat[i-2]=='m') break;
   		}
   		memcpy(mrcname,finpat,i+1);
   		mrcname[i+1]='\0';
	   	imstack.close();
	   	printf("\nOpen Image Stack: %s\n",mrcname);
	   	if(imstack.open(mrcname,"rb")==0)
	   	{
	   		printf("Failed to open: %s\n",mrcname);
	   		exit(0);
	   	}	   	
	   	n3=imstack.getNz();
   		
   		if(n3>tnset[nset-1])
   		{
   			printf(" ***WARNING*** no. of particles in stack\n");
				printf(" exceeds no. of lines in parameter file:\n");
				printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);
   		}
   		if(n3<tnset[nset-1])
   		{
   			printf(" ****ERROR**** no. of particles in stack\n");
   			printf(" smaller than no. of lines in parameter file:\n");
   			printf(" NSTACK, NPAR = %8d%8d\n",n3,tnset[nset-1]);
   			puts("Fatal error");
   			exit(0);
   		}
   		
   		if(fmatch)
   		{
   			iclose_(&ioproj);
   			n1=int(3.0*ri/icmp);
   			if((n1*icmp)>nsam) n1=nsam/icmp;
   			n2=n1;
   			n3=nnset[nset-1];
   			tnum1=2*n1;
   			iopen_(finpat2+(nset-1)*200,&ioproj,
   					&cform,&n1,&tnum1,&n3,strnew,asym,&psize,vx);
   		}
   	
   		if(njob==0)
   		{
				strlen=102;
				tempint=ndoc1+nset;
				sprintf(outputparline,"C           PSI   THETA     PHI     SHX     SHY    MAG   FILM      DF1      DF2  ANGAST  PRESA   DPRES");
				strtofile_(&tempint,outputparline,&strlen);
	 	
	 			strlen=94;
				tempint=ndoc2+nset;
				sprintf(outputparline,"C           PSI   THETA     PHI     SHX     SHY    MAG   FILM      DF1      DF2  ANGAST  PRESA");
				strtofile_(&tempint,outputparline,&strlen);
     		}
  
   	}
   }
   
   dshx=0.0;
   dshy=0.0;
   phiold=phi[k-1];
   thetaold=theta[k-1];
   psiold=psi[k-1];
   presaold=presa[k-1];
   
   if(!fdef)
   {
   	ddfmid1=0.0;
   	ddfmid2=0.0;
   	dangast=0.0;
   }
   
   if(k==nstart || k==(nstart+1)|| k%1000==0 || k==ilast)
   {
		date_and_time__(cdate, ctime, czone, dtval);
		printf(" Time before particle%6d was %c%c:%c%c:%c%c\n",
				k, ctime[0],ctime[1],ctime[2],ctime[3],ctime[4],ctime[5]);
   }
   
   //FIND FIRST PARTICLE FROM THIS FILM
   ivflag=0;
   if(fdef && (ibuf==0)) 
   {
   	ivflag=1;
   }
   else 
   {
   	if(fdef && ci) ivflag=1;
   }  
   if(fmag && (ibuf==0))
   {
   	ivflag=2;
   	amagold=amagp[k-1];
   }
   else 
   {
   	if(!fmag) amagold=amagp[k-1];
   }
   
   thetatr=wl[nset-1]/(psize*nsam);
   
   
   //read ahead to get all particles on this film for magnification or defocus refinement
   if(((fdef && !ci) || fmag) && ibuf==0)
   {
   	for(j=1;j<=npb;j++)
   	{
   		if((ifirstf+j-1)>nnpart) break;
   		if((ifirstf+j-1)>nang) break;
   		if(film[ifirstf+j-2]!=film[k-1]) break;
   		lastf=ifirstf+j-1;
   		if(presa[ifirstf+j-2]>=PI) continue;
   		ibuf++;
   		ilst[ibuf-1]=ifirstf+j-1;
   		/*ip=nsam*(abs(ilist[ifirstf+j-2])-ifirsts);
   		
   		for(i=1;i<=nsam;i++)
   		{
   			id=1+nsam*(i-1)+nsam*nsam*(ibuf-1);
   			tnum1=i+ip;
   			iread_(&inproj,&pbuf[id-1],&tnum1);
   		}
   		
   		pmin=1.0e30;
   		pmax=-1.0e30;
   		
   		id=nsam*nsam*(ibuf-1);
   		for(i=1;i<=nsam*nsam;i++)
   		{
   			if(pbuf[i+id-1]>pmax) pmax=pbuf[i+id-1];
   			if(pbuf[i+id-1]<pmin) pmin=pbuf[i+id-1];
   		}
   		
   		if(pmax==pmin)
   		{
   			printf(" ****ERROR**** blank image, N = %d\n",ifirstf+j-1);
   			printf("Fatal error\n");
   			exit(0);
   		}
   		if(pmax<=0.0 || pmin>=0.0)
   		{
   			printf(" ****ERROR**** particle not normalized, N = %d\n",ifirstf+j-1);
   			printf("Fatal error\n");
   			exit(0);
   		}*/
   		
   		id=1+nsam*nsam*(ibuf-1);
   		is=1+nsam*(ibuf-1);
   		if(imstack.read2DIm(&pbuf[id-1],abs(ilist[ifirstf+j-2])-ifirsts)!=imstack.getImSize())
   		{
   			printf("Failed to read particle: %d\n",abs(ilist[ifirstf+j-2])-ifirsts);
   		}
   		tnum1=1;
   		tnum2=1;
   		rlft3_((CPLX *)&pbuf[id-1],&pbuq[is-1],&nsam,&nsam,&tnum1,&tnum2);
   	}
   }
   
   //done only at first particle on each new film number
   if(fmag && ivflag==2)   //use ivflag to mark the first particle in a film???
   {
   	rmax1n=rmax1[nset-1];
   	rmax2n=rmax2[nset-1];
   	csn=cs[nset-1];
   	wln=wl[nset-1];
   	printf(" Refine magnification for particles %7d to %7d on film %6d     (K=%7d)",
   			ifirstf,lastf,film[k-1],k);
   	
   	magrefine(amagp,dfmid1,dfmid2,angast,ifirstf,lastf,
   			npar,nsam,maxr1,maxr2,mask,nn1,
   			c3df,c3ds,irada,outq,npb,pbuf,pbuq,
   			shx,shy,ipad,csn,wln,wgh1,wgh2,thetatr,
   			ctff,ctfs,amagp[ifirstf-1],rih,halfwc,ri2,ri3,ri4,
   			phi,theta,psi,
   			rmax1n,rmax2n,xstd,mbuf,
   			ilst,datc,datq,ibuf,b3dv,datd,sinclut,ivflag,
   			rbfact,outd,outc,qbuc,qbuq,bf,fsct,film,ilast,
   			iewald,tx[nset-1],ty[nset-1]);
   			
   	printf("                      absolute magnification =%9.1f",
   			1.0/amagp[ifirstf-1]*dstep[nset-1]*10000.0/psize);
   					
   	if(fdef) ivflag=1;
   	else ivflag=0;
   }
   
   //done only at first particle on each new film number
   if(fdef && !ci && ivflag==1)
   {
   	rmax1n=rmax1[nset-1];
   	rmax2n=rmax2[nset-1];
   	csn=cs[nset-1];
   	wln=wl[nset-1];
   	printf(" Refine defocus for particles %7d to %7d on film %6d     (K=%7d)\n",
   			ifirstf,lastf,film[k-1],k);
   			
   	/*ctfrefine_(dfmid1,dfmid2,angast,&ifirstf,&lastf,&fastig,
   			&npar,&nsam,&maxr1,&maxr2,mask,&nn1,&ddfmid1,&ddfmid2,&dangast,
   			c3df,c3ds,&irada,outq,&npb,(CPLX *)pbuf,pbuq,shx,shy,&ipad,
   			&csn,&wln,&wgh1,&wgh2,&thetatr,ctff,ctfs,amagp,&rih,
   			&halfwc,&ri2,&ri3,&ri4,phi,theta,psi,
   			&rmax1n,&rmax2n,&xstd,
   			mbuf,ilst,datc,datq,&ibuf,b3dv,datd,sinclut,&ivflag,&rbfact,
   			outd,outc,qbuc,qbuq,&ci,bf,fsct,film,&ilast,&iewald,
   			&tx[nset-1],&ty[nset-1]);*/
   	ctfrefine(dfmid1,dfmid2,angast,ifirstf,lastf,fastig,
   			npar,nsam,maxr1,maxr2,mask,nn1,ddfmid1,ddfmid2,dangast,
   			c3df,c3ds,irada,outq,npb,pbuf,(CPLX *)pbuq,shx,shy,ipad,
   			csn,wln,wgh1,wgh2,thetatr,ctff,ctfs,amagp,rih,
   			halfwc,ri2,ri3,ri4,phi,theta,psi,
   			rmax1n,rmax2n,xstd,
   			mbuf,ilst,datc,datq,ibuf,b3dv,datd,sinclut,ivflag,rbfact,
   			outd,outc,qbuc,qbuq,ci,bf,fsct,film,ilast,iewald,
   			tx[nset-1],ty[nset-1]);
   			
   	ivflag=0;
   }
   
   //criterion for inclusion depends on THRESH
   if((thresh[nset-1]<0.0 && presa[k-1]<PI) || thresh[nset-1]>=0.0)
   {
      //then need to read in particle images because they were not
      // already read in for defocus or magnification refinement
      /*ip=nsam*(abs(ilist[k-1])-ifirsts);
      //lock_();
      for(i=1;i<=nsam;i++)
      {
      	id=1+nsam*(i-1);
      	tnum1=i+ip;
      	iread_(&inproj,&data[id-1],&tnum1);
      }
      //unlock_();
      pmin=1.0e30;
      pmax=-1.0e30;
      for(i=1;i<=nsam*nsam;i++)
   	{
   		if(data[i-1]>pmax) pmax=data[i-1];
   		if(data[i-1]<pmin) pmin=data[i-1];
   	}
   		
   	if(pmax==pmin)
   	{
   		printf(" ****ERROR**** blank image, N = %d\n",k);
   		printf("Fatal error\n");
   		exit(0);
   	}
   	if(pmax<=0.0 || pmin>=0.0)
   	{
   		printf(" ****ERROR**** particle not normalized, N = %d\n",k);
   		printf("Fatal error\n");
   		exit(0);
   	}*/
   	
   	imstack.read2DIm(data,abs(ilist[k-1])-ifirsts);
   	
   	tnum1=1;
   	tnum2=1;	
   	rlft3_((CPLX *)data,speq,&nsam,&nsam,&tnum1,&tnum2);
   	
   	if(fdef && ci && ivflag==1)
   	{
   		rmax1n=rmax1[nset-1];
   		rmax2n=rmax2[nset-1];
   		csn=cs[nset-1];
   		wln=wl[nset-1];
   		ibufb=ibuf;
   		ibuf=1;
   		ilst[ibuf-1]=k;
   		
   		/*ctfrefine_(&dfmid1[k-1],&dfmid2[k-1],&angast[k-1],&ifirstf,
   					&lastf,&fastig,&npar,&nsam,&maxr1,&maxr2,mask,&nn1,&ddfmid1,
   					&ddfmid2,&dangast,c3df,c3ds,&irada,outq,&npb,spec,speq,
   					shx,shy,&ipad,&csn,&wln,&wgh1,&wgh2,&thetatr,ctff,ctfs,
   					amagp,&rih,&halfwc,&ri2,&ri3,&ri4,phi,theta,psi,
   					&rmax1n,&rmax2n,&xstd,
   					mbuf,ilst,datc,datq,&ibuf,b3dv,datd,sinclut,
   					&ivflag,&rbfact,outd,outc,qbuc,qbuq,&ci,bf,fsct,film,&ilast,
   					&iewald,&tx[nset-1],&ty[nset-1]);*/
   		ctfrefine(&dfmid1[k-1],&dfmid2[k-1],&angast[k-1],ifirstf,
   					lastf,fastig,npar,nsam,maxr1,maxr2,mask,nn1,ddfmid1,
   					ddfmid2,dangast,c3df,c3ds,irada,outq,npb,(float *)spec,speq,
   					shx,shy,ipad,csn,wln,wgh1,wgh2,thetatr,ctff,ctfs,
   					amagp,rih,halfwc,ri2,ri3,ri4,phi,theta,psi,
   					rmax1n,rmax2n,xstd,
   					mbuf,ilst,datc,datq,ibuf,b3dv,datd,sinclut,
   					ivflag,rbfact,outd,outc,qbuc,qbuq,ci,bf,fsct,film,ilast,
   					iewald,tx[nset-1],ty[nset-1]);
   								
   		if(iout) printf(" Refined defocus for particle %7d = %9.1f%9.1f%9.1f\n",
   				k,dfmid1[k-1],dfmid2[k-1],angast[k-1]/PI*180.0);
   		ivflag=0;
   		ibuf=ibufb;
   	}

   	tnum1=0;
   	ctfapply(&nsam, spec, speq, &shx[k-1], &shy[k-1], &cs[nset-1], 
   			&wl[nset-1], &wgh1, &wgh2, &dfmid1[k-1], &dfmid2[k-1], &angast[k-1], 
   			&thetatr, ctff, ctfs, outd, outc, outq, &amagp[k-1], &rih, &halfw, 
   			&ri2, &ri3, &ri4, datd, datc, datq, b3dv, &phi[k-1], &theta[k-1], 
   			&psi[k-1], mbuf, &xstd, &tnum1, &tx[nset-1], &ty[nset-1]);
	
		//copy ctff to texture		
		if(iflag!=0)
		{
			cuMem *pGM=(cuMem *)pthread_getspecific(cuMemKey);
			cudaMemcpyToArray(pGM->cu_ctff, 0, 0, pGM->d_ctff, sizeof(CPLX)*nsam*nsam,cudaMemcpyDeviceToDevice);
		}

   	sigma2(&sig2, &nsam, &irada, &amagp[k-1], c3df, c3ds, datc, datq, 
   			&phi[k-1], &theta[k-1], &psi[k-1], &dshx,	&dshy, sinclut, 
   			&ipad, &iewald, &thetatr,ctff, ctfs, bf);

		/*gettimeofday(&begin,NULL);
		float test=cc3m(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   								maxr1,maxr2,phi[k-1],theta[k-1],psi[k-1],dshx,dshy,
   								rbfact,sinclut,ipad,bf,fsct,iewald,
   								thetatr,ctff,ctfs,ri2,ri3,rih,halfw);
   	gettimeofday(&end,NULL);
		printf(" @  %15d\n",CalTime(begin,end));*/

   				
   	if(fdef || fmag)
   	{
   		presa[k-1]=cc3m(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   								maxr1,maxr2,phi[k-1],theta[k-1],psi[k-1],dshx,dshy,
   								rbfact,sinclut,ipad,bf,fsct,iewald,
   								thetatr,ctff,ctfs,ri2,ri3,rih,halfw)-
   					  fsh(sig2,dshx,dshy,xm[nset-1]-shx[k],
   					  			ym[nset-1]-shy[k-1],sx[nset-1],sy[nset-1]);
   	}

   	if(iflag>=3)
   	{
   		maxr1=int(nsam*rmax1[nset-1]*abs(amagp[k-1]));
   		maxr2=int(nsam*rmax2[nset-1]*abs(amagp[k-1]));
   		maxres=int(nsam*rrec[nset-1]*abs(amagp[k-1]));
   		rbfact=rbfac[nset-1]/(4.0*pow((nsam*psize*amagp[k-1]),2));
   		bestp=2.0*PI;
   		jj=(nsang<ipmax)?nsang:ipmax;
   		testpar[0+jj*6]=phi[k-1];
   		testpar[1+jj*6]=theta[k-1];
   		testpar[2+jj*6]=psi[k-1];
   		testpar[3+jj*6]=0.0;
   		testpar[4+jj*6]=0.0;
   		   
   							   				
   		for(i=1;i<=itmax;i++)
   		{
   																	//gettimeofday(&begin,NULL);
   			psearch(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   					maxr1,maxr2,phi[k-1],theta[k-1],psi[k-1],dshx,
   					dshy,/*presa[k-1],*/sang,nsang,ccd,ccc,ccs,ccbuf,iquadmax,
   					mask,rbfact,sinclut,ipad,bf,fsct,iewald,thetatr,
   					//ctff,ctfs,
   					ri2,ri3,rih,halfw,testpar,ipmax);
																		//gettimeofday(&end,NULL);
																		//printf("%6d  %15d\n",k,CalTime(begin,end));
   			presa[k-1]=2.0*PI;
   			jj=(nsang<ipmax)?nsang:ipmax;
   			if(i==1) jj++;
   			for(j=1;j<=jj;j++)
   			{
   				prefine(nsam,irada,amagp[k-1],
   						maxr1,maxr2,testpar[0+(j-1)*6],testpar[1+(j-1)*6],testpar[2+(j-1)*6],
   						testpar[3+(j-1)*6],testpar[4+(j-1)*6],presn,mask,rbfact,npar,nn1,
   						c3df,c3ds,outq,npb,pbuf,pbuq,shx[k-1],shy[k-1],ipad,
   						csn,wln,wgh1,wgh2,thetatr,ctff,ctfs,amagp[k-1],rih,
   						halfwc,ri2,ri3,ri4,rmax1n,rmax2n,xstd,mbuf,
   						ilst,datc,datq,ibuf,b3dv,datd,sinclut,ivflag,
   						outd,outc,qbuc,qbuq,bf,fsct,iewald,xm[nset-1],ym[nset-1],
   						sx[nset-1],sy[nset-1],sig2);
   						//printf("%d  %d  %11.8f\n",k,j,presn);
   				if(presn<presa[k-1])
   				{
   					presa[k-1]=presn;
   					phi[k-1]=testpar[0+(j-1)*6];
   					theta[k-1]=testpar[1+(j-1)*6];
   					psi[k-1]=testpar[2+(j-1)*6];
   					dshx=testpar[3+(j-1)*6];
   					dshy=testpar[4+(j-1)*6];
   				}
   			}
   			
   			if(iflag==3) break;//goto 250;
   			
   			if(fhist) 
   			{	
   				sprintf(outputparline,
   					"%7d%8.2f%8.2f%8.2f%8.2f%8.2f%8.0f%6d%9.1f%9.1f%8.2f%7.2f%8.2f",
   					abs(ilist[k-1]), psi[k-1]/PI*180,
   					psi[k-1]/PI*180, theta[k-1]/PI*180, phi[k-1]/PI*180,
   					-(shx[k-1]+dshx)*nsam/PI/2.0, -(shy[k-1]+dshy)*nsam/PI/2.0,
   					(1.0/abs(amagp[k-1]))*dstep[nset-1]*10000/psize,
   					film[k-1],dfmid1[k-1],dfmid2[k-1],
   					angast[k-1]/PI*180,presa[k-1]/PI*180);
   				outputpar(njob,outputparline);
				}
				
				//here for IFLAG=4, store best parameters
				if(presa[k-1]<bestp)
				{
					bestp=presa[k-1];
					
					bestphi=phi[k-1];
					besttheta=theta[k-1];
					bestpsi=psi[k-1];
					bestdshx=dshx;
					bestdshy=dshy;
					
					bestamag=amagp[k-1];
					bestdfmid1=dfmid1[k-1];
					bestdfmid2=dfmid2[k-1];
					bestangast=angast[k-1];
				}
				
				//criterion for ending search/refine depends on TARGET
				if(presa[k-1]<=abs(target[nset-1])) //goto 240;
				{
					maxr2++;
					while(maxr2<=maxres)
					{
						
						prefine(nsam,irada,amagp[k-1],
   							maxr1,maxr2,phi[k-1],theta[k-1],psi[k-1],	dshx,dshy,
   							presa[k-1],mask,rbfact,npar,nn1,
   							c3df,c3ds,outq,npb,pbuf,pbuq,shx[k-1],shy[k-1],ipad,
   							csn,wln,wgh1,wgh2,thetatr,ctff,ctfs,amagp[k-1],rih,
   							halfwc,ri2,ri3,ri4,rmax1n,rmax2n,xstd,mbuf,
   							ilst,datc,datq,ibuf,b3dv,datd,sinclut,ivflag,
   							outd,outc,qbuc,qbuq,bf,fsct,iewald,xm[nset-1],ym[nset-1],
   							sx[nset-1],sy[nset-1],sig2);
//L 240:   					
						//extend resolution out to limit of reconstruction when IFLAG.eq.4	
						maxr2++;			
					}
					break;
				}
				
				phi[k-1]+=random(iran)*damax*float(mask[0]);				
				psi[k-1]+=random(iran)*damax*float(mask[2]);
				theta[k-1]+=random(iran)*damax*float(mask[1]);
   		}
   			
   		//if IFLAG=4, do not set to PI if residual > THRESH, but restore
			//best params and best phase residual
			if(iflag==4 && i>itmax)
			{
				presa[k-1]=bestp;
			
				phi[k-1]=bestphi;
				theta[k-1]=besttheta;
				psi[k-1]=bestpsi;
				dshx=bestdshx;
				dshy=bestdshy;
					
				amagp[k-1]=bestamag;
				dfmid1[k-1]=bestdfmid1;
				dfmid2[k-1]=bestdfmid2;
				angast[k-1]=bestangast;
			}
			//goto 250;			
			
//L 250:			
   		if(iflag==4)
   		{
   			if(iout) printf(" Best phase residual for particle %6d at Rmin/Rmax %6.1f%6.1f:%13.3f\n",
   					k,psize/rmax1[nset-1],psize/rmax2[nset-1],presa[k-1]/PI*180);
   		}
   		
   		//accumulate overall phase residual in resolution bins
   		tfnum1=thetatr/amagp[k-1];
   		/*presb_(&nsam,&irada,&amagp[k-1],outc,outq,c3df,c3ds,
   				&maxr1,&maxr2,&phi[k-1],&theta[k-1],&psi[k-1],&dshx,&dshy,rbin,
   				sinclut,&ipad,ns,&bf[0],&bf[nsam],&bf[2*nsam],
   				&cs[nset-1],&wl[nset-1],&wgh1,&wgh2,&dfmid1[k-1],&dfmid2[k-1],
   				&angast[k-1],&tfnum1,&iewald,ctff,ctfs,
   				&ri2,&ri3,&rih,&halfw);*/
   		presb(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   					phi[k-1],theta[k-1],psi[k-1],dshx,dshy,rbin,
   					sinclut,ipad,bf,tfnum1,iewald,ctff,ctfs,
   					ri2,ri3,rih,halfw);
   				
   		for(i=1;i<=nsam;i++)
   		{
   			rawbins[i-1]+=rbin[i-1];
   		}
   	}
   	
   	if(iflag==1 || iflag==2)
   	{
   		itf=1;
   		fflag=0;
   		if(fflip) itf=2;
   		presmin2=2.0*PI;
   		for(j=1;j<=itf;j++)
   		{
   			itt=1;
   			if(iflag==2) itt=itmax;
   			presmin=2.0*PI;
   			
   			for(i=1;i<=itt;i++)
   			{
   				maxr1=int(nsam*rmax1[nset-1]*abs(amagp[k-1]));
   				maxr2=int(nsam*rmax2[nset-1]*abs(amagp[k-1]));
   				rbfact=rbfac[nset-1]/(4.0*pow(nsam*psize*amagp[k-1],2));
   				
   				do
   				{
   					   			//gettimeofday(&begin,NULL);
   					prefine(nsam,irada,amagp[k-1],
   							maxr1,maxr2,phi[k-1],theta[k-1],psi[k-1],dshx,dshy,
   							presa[k-1],mask,rbfact,npar,nn1,
   							c3df,c3ds,outq,npb,pbuf,pbuq,shx[k-1],shy[k-1],ipad,
   							csn,wln,wgh1,wgh2,thetatr,ctff,ctfs,amagp[k-1],rih,
   							halfwc,ri2,ri3,ri4,rmax1n,rmax2n,xstd,mbuf,
   							ilst,datc,datq,ibuf,b3dv,datd,sinclut,ivflag,
   							outd,outc,qbuc,qbuq,bf,fsct,iewald,xm[nset-1],ym[nset-1],
   							sx[nset-1],sy[nset-1],sig2);
   							   			//gettimeofday(&end,NULL);
   							
   					maxr2++;
   				}while(maxr2<=int(nsam*rmax2[nset-1]*abs(amagp[k-1])));
   				
   				if(presmin>presa[k-1])
   				{
   					presmin=presa[k-1];
   					phim=phi[k-1];
   					thetam=theta[k-1];
   					psim=psi[k-1];
   					dshxm=dshx;
   					dshym=dshy;
   					amagm=amagp[k-1];
   					if(i!=1) fflag=1;
   				}
   				else
   				{
   					presa[k-1]=presmin;
   					phi[k-1]=phim;
   					theta[k-1]=thetam;
   					psi[k-1]=psim;
   					dshx=dshxm;
   					dshy=dshym;
   					amagp[k-1]=amagm;
   				}
   				phi[k-1]+=(random(iran)-0.5)*damax*float(mask[0]);
   				theta[k-1]+=(random(iran)-0.5)*damax*float(mask[1]);
   				psi[k-1]+=(random(iran)-0.5)*damax*float(mask[2]);
   				dshx+=(random(iran)-0.5)*dsmax*float(mask[3]);
   				dshy+=(random(iran)-0.5)*dsmax*float(mask[4]);
   			}
   			
   			if(presmin<presmin2)
   			{
   				presmin2=presmin;
   				phim2=phim;
   				thetam2=thetam;
   				psim2=psim;
   				dshxm2=dshxm;
   				dshym2=dshym;
   				amagm2=amagm;
   				if(j==2)
   				{
   					printf(" **** PROJECTION %6d FLIPPED ****\n",k);
   					fflag=1;
   				}
   			}
   			
   			phi[k-1]=phiold;
   			theta[k-1]=-thetaold;
   			psi[k-1]=psiold;
   			dshx=0.0;
   			dshy=0.0;
   		}
   		
   		presa[k-1]=presmin2;
   		phi[k-1]=phim2;
   		theta[k-1]=thetam2;
   		psi[k-1]=psim2;
   		dshx=dshxm2;
   		dshy=dshym2;
   		amagp[k-1]=amagm2;
   		
   		//accumulate overall phase residual in resolution bins
   		tfnum1=thetatr/amagp[k-1];
   		/*presb_(&nsam,&irada,&amagp[k-1],outc,outq,c3df,c3ds,
   				&maxr1,&maxr2,&phi[k-1],&theta[k-1],&psi[k-1],&dshx,&dshy,rbin,
   				sinclut,&ipad,ns,&bf[0],&bf[nsam],&bf[2*nsam],
   				&cs[nset-1],&wl[nset-1],&wgh1,&wgh2,&dfmid1[k-1],&dfmid2[k-1],
   				&angast[k-1],&tfnum1,&iewald,ctff,ctfs,
   				&ri2,&ri3,&rih,&halfw);*/
   		presb(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   					phi[k-1],theta[k-1],psi[k-1],dshx,dshy,rbin,
   					sinclut,ipad,bf,tfnum1,iewald,ctff,ctfs,
   					ri2,ri3,rih,halfw);
   		for(i=1;i<=nsam;i++)
   		{
   			rawbins[i-1]+=rbin[i-1];
   		}
   		
   		//Calculate cross-correlation
   				
   		//ccoef_(&ccpart,&nsam,&irada,&amagp[k-1],c3df,c3ds,datc,datq,
   		//			&phi[k-1],&theta[k-1],&psi[k-1],&dshx,&dshy,sinclut,
   		//			&ipad,&iewald,&thetatr,ctff,ctfs,bf);
   		ccpart=ccoef(nsam,irada,amagp[k-1],c3df,c3ds,datc,datq,
   					phi[k-1],theta[k-1],psi[k-1],dshx,dshy,sinclut,
   					ipad,iewald,thetatr,ctff,ctfs,bf);
   		if(iout) printf(" CC for particle %6d is %12.8f   phase residual is %7.2f\n",
   				k,ccpart,presa[k-1]*180/PI);
   		ccave+=ccpart;  //sum of all cc
   		iccount++;    //numbers of cc
   		
   	}

   	//criterion for insertion depends on THRESH
   	if((iflag<=3 && presa[k-1]<=abs(thresh[nset-1])) || 
   	   (iflag==4 && presa[k-1]<PI))
   	{
   		maxr1=int(nsam*rmax1[nset-1]*abs(amagp[k-1]));
   		maxr2=int(nsam*rmax2[nset-1]*abs(amagp[k-1]));
   		rbfact=rbfac[nset-1]/(4.0*pow(nsam*psize*amagp[k-1],2));
   		
   		//Put alternating particles into A3 or D3 
   		if(iflag==0 && istat==1)
   		{
   			tfnum1=thetatr/amagp[k-1];
   			/*presb_(&nsam,&irada,&amagp[k-1],outc,outq,c3df,c3ds,
   					&maxr1,&maxr2,&phi[k-1],&theta[k-1],&psi[k-1],&dshx,&dshy,rbin,
   					sinclut,&ipad,ns,&bf[0],&bf[nsam],&bf[2*nsam],
   					&cs[nset-1],&wl[nset-1],&wgh1,&wgh2,&dfmid1[k-1],&dfmid2[k-1],
   					&angast[k-1],&tfnum1,&iewald,ctff,ctfs,
   					&ri2,&ri3,&rih,&halfw);*/
   			presb(nsam,irada,amagp[k-1],outc,outq,c3df,c3ds,
   					phi[k-1],theta[k-1],psi[k-1],dshx,dshy,rbin,
   					sinclut,ipad,bf,tfnum1,iewald,ctff,ctfs,
   					ri2,ri3,rih,halfw);
   			for(i=1;i<=nsam;i++)
   			{
   				rawbins[i-1]+=rbin[i-1];
   			}
   		}
   		
   		if(fall)
   		{
   			if(istat==1)
   			{	
   				variance_(&nsam,spec,speq,&shx[k-1],&shy[k-1],&ri,
   						&bf[0],(CPLX *)&bf[0],(CPLX *)&bf[nsam*nsam],&bf[2*nsam*nsam],
   						(CPLX *)&bf[2*nsam*nsam],(CPLX *)&bf[3*nsam*nsam],ic,vsn,vn,
   						vvsn,vvn,&amagp[k-1],&bf[4*nsam*nsam],&na);  						
   			}
   			a3d3_(&nset,&iswitch,&nsam,&irad,&ri,rrec,
   					&amagp[k-1],datc,datq,ctff,ctfs,asum,vsum,psum,c3df,
   					ksum,&phi[k-1],&theta[k-1],&psi[k-1],&dshx,&dshy,&presa[k-1],&pbc,
   					&boff,a3df,a3ds,s3df,s3ds,&std,d3df,d3ds,v3df,v3ds,&vtd,
   					&nn1,&maxset,sinclut,&irada,&ipad,&thetatr,&iewald,c3ds,
   					sumprel,nprel,&nsym,isym,jsym,symop,&nnstat,&nksum,
   					&ifsc,&imp);	
   		}
   		pall+=presa[k-1]; //sum of all presa
   		iall++;  //number of presa
   	}
   	else
   	{
   		//if(fall && iout) printf(" **** PROJECTION %6d ABOVE THRESHOLD NOT INCLUDED\n",k);
   		iexcl++; //number of particles excluded 
   	}
   	
   }
   else
   {
   	//if(iout) printf(" **** PROJECTION %6d ABOVE THRESHOLD NOT INCLUDED\n",k);
   	iexcl++; //number of particles excluded 
   }
   
   if(iflag>0 || fdef || fmag)
   {
   	press+=presa[k-1]/PI*180;
   	if(phi[k-1]<0.0) phi[k-1]+=2.0*PI;
   	if(theta[k-1]<0.0) theta[k-1]+=2.0*PI;
   	if(psi[k-1]<0.0) psi[k-1]+=2.0*PI;
   	
   	sprintf(outputparline,
   			"%7d%8.2f%8.2f%8.2f%8.2f%8.2f%8.0f%6d%9.1f%9.1f%8.2f%7.2f%8.2f",
   			abs(ilist[k-1]), psi[k-1]/PI*180,
   			theta[k-1]/PI*180, phi[k-1]/PI*180,
   			-(shx[k-1]+dshx)*nsam/PI/2.0, -(shy[k-1]+dshy)*nsam/PI/2.0,
   			(1.0/abs(amagp[k-1]))*dstep[nset-1]*10000/psize,
   			film[k-1],dfmid1[k-1],dfmid2[k-1],
   			angast[k-1]/PI*180,presa[k-1]/PI*180, (presa[k-1]-presaold)/PI*180);
   	outputpar(njob,outputparline);
   	
   	dpsi=psi[k-1]-psiold-int((int((psi[k-1]-psiold)/PI)+1)/2.0)*2.0*PI;
   	dtheta=theta[k-1]-thetaold-int((int((theta[k-1]-thetaold)/PI)+1)/2.0)*2.0*PI;
   	dphi=phi[k-1]-phiold-int((int((phi[k-1]-phiold)/PI)+1)/2.0)*2.0*PI;
   	
   	/*sprintf(outputparline,
   			"%7d%8.2f%8.2f%8.2f%8.2f%8.2f%8.0f%6d%9.1f%9.1f%8.2f%7.2f%8.2f",
   			abs(ilist[k-1]), dpsi/PI*180,
   			dtheta/PI*180, dphi/PI*180,
   			-dshx*nsam/PI/2.0, -dshy*nsam/PI/2.0,
   			(1.0/abs(amagp[k-1])-1.0/abs(amagold))*dstep[nset-1]*10000/psize,
   			film[k-1],ddfmid1,ddfmid2,
   			dangast/PI*180,(presa[k-1]-presaold)/PI*180);
   	tempint=ndoc2+nset;
	 	strlen=102;
	 	strtofile_(&tempint,outputparline,&strlen);
	 	fflush_(&(tempint));*/
	 	fprintf(fp,
   			"%7d%8.2f%8.2f%8.2f%8.2f%8.2f%8.0f%6d%9.1f%9.1f%8.2f%7.2f%8.2f\n",
   			abs(ilist[k-1]), dpsi/PI*180,
   			dtheta/PI*180, dphi/PI*180,
   			-dshx*nsam/PI/2.0, -dshy*nsam/PI/2.0,
   			(1.0/abs(amagp[k-1])-1.0/abs(amagold))*dstep[nset-1]*10000/psize,
   			film[k-1],ddfmid1,ddfmid2,
   			dangast/PI*180,(presa[k-1]-presaold)/PI*180);
   	fflush(fp);
	 	
/*	 	int ostep=(ilast-nstart)/20;
	 	if(ostep<=0) ostep=1;

	 	if((k-nstart)%ostep==0)
	 	{
			date_and_time__(cdate, ctime, czone, dtval);
	 		sprintf(outputparline,"%4d%% finished in thread #%02d. time: %c%c:%c%c:%c%c\n",
	 					(k-nstart)/ostep*5,njob,
	 					ctime[0],ctime[1],ctime[2],ctime[3],ctime[4],ctime[5]);
	 		tempint=ndoc2+nset;
	 		strlen=44;
	 		strtofile_(&tempint,outputparline,&strlen);
	 		fflush_(&(tempint));
	 	}*/
	 	
	 	psis+=pow(dpsi/PI*180,2);
	 	thetas+=pow(dtheta/PI*180,2);
	 	phis+=pow(dphi/PI*180,2);
	 	dshxs+=pow(dshx*nsam/PI/2.0,2);
	 	dshys+=pow(dshy*nsam/PI/2.0,2);
	 	
	 	absmags+=pow(abs(amagp[k-1])-abs(amagold),2)*pow(dstep[nset-1]*10000/psize,2);
	 	dfmid1s+=pow(ddfmid1,2);
	 	dfmid2s+=pow(ddfmid2,2);
	 	angasts+=pow(dangast/PI*180,2);
	 	icount++;
	 	
	 	if(fflag==1) 
	 	{
	 		printf(" **** NEW LOCAL MINIMUM FOR PROJECTION%6d\n",k);
	 		printf(" dPSI, dTHETA, dPHI, dX, dY = %8.2f%8.2f%8.2f   %6.2f%6.2f\n",
	 				(psi[k-1]-psiold)/PI*180, (theta[k-1]-thetaold)/PI*180,
	 				(phi[k-1]-phiold)/PI*180, -dshx*nsam/PI/2.0, -dshy*nsam/PI/2.0);
	 	}	 	
   	
   }
   
   //Output of matching projections if requested and MASKENV
   if(fmatch)
   {
   	match_(&k, &nsam, &irada, outc, outd,
   		outq, c3df, c3ds, &phi[k-1], &theta[k-1],
   		&psi[k-1], &jc, &nsamh, &phase, &shx[k-1],
   		&shy[k-1], &dshx, &dshy, &nn1, &xstd,
   		&ri, b3dv, mbuf, &icmp, data, 
   		speq,	&ccpart, &presa[k-1], &presaold, thresh,
   		&cform, &maxset, &npb, &ilist[k-1], &ifirst,
   		&nset, &ioproj, sinclut, &ipad, &thetatr,
   		&iewald, ctff, ctfs);
   }
   
//  gettimeofday(&end0,NULL);
   //printf("%6d  %15d %15d\n",k,CalTime(begin,end),CalTime(begin0,end0));
	//cout<<" **************** lmain is "<<CalTime(begin0,end0)<<"  "<<float(CalTime(begin,end))*100/float(CalTime(begin0,end0))<<endl;
   

   
   
   return;
}			
			
		
		
		
		
		 
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
			
			
