#include "prefine_gpu.h"
#include "cc3m_gpu.h"
#include "fsh_gpu.h"
#include "va04_gpu.h"
	
	
void prefine(int nsam, int irad, float amag, 
		int maxr1, int maxr2, float &phi, float &theta, float &psi, 
		float &dshx, float &dshy, float &presa, int *mask, float &rbfact, 
		int &npar, int nn1, CPLX *c3df, CPLX *c3ds, CPLX *
		outq, int &npb, float *pbuf, CPLX *pbuq, float &shx, float &shy, 
		int &ipad, float cs, float wl, float &wgh1, float &wgh2, float &
		thetatr, CPLX *ctff, CPLX *ctfs, float &amagp, float &rih, float &
		halfw, float &ri2, float &ri3, float &ri4, float &rmax1, float &rmax2, 
		float &xstd, float *mbuf, int *ilst, CPLX *datc, CPLX *datq, 
		int ibuf, float *b3dv, float *datd, float *sinclut, int &ivflag,
	 	float *outd, CPLX *outc, CPLX *qbuc, CPLX *qbuq, float *rbuf, 
		float *fsct, int iewald, float &xm, float &ym, float &sx, float &sy, 
		float &sig2)
{
	int jpar, ipar;
	int ncycls=50;
	float xpar[6], dumr=0, eparmap[6], xparmap[6];
	float epar[6] = { 0.1f,0.1f,0.1f,0.01f,0.01f,0.001f };
	float escale = 100.0f;
	
	xpar[0] = phi;
	xpar[1] = theta;
	xpar[2] = psi;
	xpar[3] = dshx;
	xpar[4] = dshy;
	xpar[5] = abs(amag);
	
	//  pack variables to be refined into XPARMAP using MASK
	ipar=0;
	for(jpar=1;jpar<=5;++jpar) 
	{
		if(mask[jpar-1]==1) 
		{
			++ipar;
			xparmap[ipar-1]=xpar[jpar-1];
			eparmap[ipar-1]=epar[jpar-1];
		}
	}
   npar = ipar;
	presa = -cc3m(nsam, irad, amag, outc, outq, c3df, c3ds, 
				maxr1, maxr2, phi, theta, psi, dshx, dshy, 
				rbfact, sinclut, ipad, rbuf, fsct, iewald, thetatr, 
				ctff, ctfs, ri2, ri3, rih, halfw) 
				-fsh(sig2, dshx, dshy, xm-shx, ym-shy, sx, sy);

	if (amag<0.0f) 
	{
		++npar;
		xparmap[npar-1]=xpar[5];
		eparmap[npar-1]=epar[5];
		va04a(xparmap, eparmap, npar, presa, escale, 0, 1, ncycls, 
			xpar, npar, nsam, maxr1, maxr2, mask, nn1, c3df, 
			c3ds, irad, outq, npb, pbuf, pbuq, &shx, &shy, 
			ipad, cs, wl, wgh1, wgh2, thetatr, ctff, ctfs, &amagp, 
			rih, halfw, ri2, ri3, ri4, &phi, &theta, &psi, rmax1, rmax2, 
			xstd, mbuf, ilst, datc, datq, ibuf, b3dv, 
			datd, sinclut, ivflag, rbfact, outd, outc, 
			qbuc, qbuq, rbuf, fsct, &dumr, &dumr, &dumr, 
			iewald, 0.0, 0.0, xm-shx, ym-shy, sx, sy, sig2);

		xpar[5] = xparmap[npar - 1];
		//seldom used w. above magnification refinement on individual particles
	} 
	else 
	{
		if (npar!=0) 
		{
			va04a(xparmap, eparmap, npar, presa, escale, 0, 1, ncycls, 
					xpar, npar, nsam, maxr1, maxr2, mask, nn1, 
					c3df, c3ds, irad, outq, npb, pbuf, pbuq, 
					&shx, &shy, ipad, cs, wl, wgh1, wgh2, thetatr, ctff, 
					ctfs, &amagp, rih, halfw, ri2, ri3, ri4, &phi, &theta, 
					&psi, rmax1, rmax2, xstd, mbuf, ilst, datc, 
					datq, ibuf, b3dv, datd, sinclut, ivflag, 
					rbfact, outd, outc, qbuc, qbuq, rbuf, 
					fsct, &dumr, &dumr, &dumr, iewald, 0.0, 0.0, 
					xm-shx,ym-shy, sx, sy, sig2);

		}
	}
/*  unpack variables after refinement into XPAR using MASK */
	ipar = 0;
	for (jpar=1;jpar<=5;++jpar) 
	{
		if (mask[jpar-1]==1) 
		{
			++ipar;
			xpar[jpar-1]=xparmap[ipar-1];
		}
	}

	phi = xpar[0];
	theta = xpar[1];
	psi = xpar[2];
	dshx = xpar[3];
   dshy = xpar[4];
	amag = abs(amag)/amag*xpar[5];

	presa=-presa-fsh(sig2, dshx, dshy, xm-shx, ym-shy, sx, sy);
	presa = acos(presa);
	return;
}
