#include "psearch_gpu.h"
#include "ccp_gpu.h"


void psearch(int nsam, int irad, float amag, 
	CPLX *spec, CPLX *speq, CPLX *a3df, CPLX *a3ds, int maxr1, int maxr2, 
	float &phi, float &theta, float &psi, float &dshx, float &dshy, //float &presa, 
	float *sang, int nsang, float *ccd, CPLX *ccc, CPLX *ccs, CPLX *cbuf, 
	int iquadmax, int *mask, float rbfact, float *sinclut, int ipad, 
	float *rbuf, float *fsct, int iewald, float thetatr, //CPLX *ctff, CPLX *ctfs, 
	float ri2, float ri3, float rih, float halfw, float *testpar, int	ipmax)
{
	int i,j,k,kk,i3,iquad;
	float cc=0.0f,phi1=0.0f,theta1=0.0f,psi1=0.0f,xpar[5],ccmax=-1e30f;

	for(k=0;k<ipmax;++k)
	{
		testpar[k*6+5]=0.0f;
	}

	for(i=1;i<=nsang;++i)
	{
		i3=i*3;
		xpar[0]=mask[0]*sang[i3-3]+phi;
		xpar[1]=mask[1]*sang[i3-2]+theta;
		xpar[2]=mask[2]*sang[i3-1]+psi;
		if(xpar[0]>PI) xpar[0]+=-2.0f*PI;
		if(xpar[1]>PI) xpar[1]+=-2.0f*PI;
		if(xpar[2]>PI) xpar[2]+=-2.0f*PI;
		xpar[3]=0.0f;
		xpar[4]=0.0f;

		ccp(nsam,irad,amag,spec,speq,a3df,a3ds,rbuf,maxr1,maxr2,
			xpar[0],xpar[1],xpar[2],xpar[3],xpar[4],cc,ccd,ccc,ccs,
			cbuf,iquad,mask,rbfact,sinclut,ipad,iewald,thetatr,
			//ctff,ctfs,
			ri2,ri3,rih,halfw,iquadmax);

		if(xpar[2]>PI) xpar[2]+=-2.0f*PI;

		for(k=1;k<=ipmax;++k)
		{
			if(cc>testpar[k*6-1])
			{
				for(kk=ipmax;kk>=(k+1);--kk)
					for(j=1;j<=6;++j)
					{
						testpar[j-1+(kk-1)*6]=testpar[j-1+(kk-2)*6];
					}
				for(j=1;j<=5;++j)
				{
					testpar[j-1+(k-1)*6]=xpar[j-1];
				}
				testpar[k*6-1]=cc;
				break;
			}
		}

		if(cc>ccmax)
		{
			ccmax=cc;
			phi1=xpar[0];
			theta1=xpar[1];
			psi1=xpar[2];
			dshx=xpar[3];
			dshy=xpar[4];
			//on entry to PSEARCH, DSHX and DSHY are normally zero 
		}
	}
	phi=phi1;
	theta=theta1;
	psi=psi1;

	return;

}





