#include "rotate2d_gpu.h"

#include "pad.h"

static __device__ CPLX conjg(CPLX f)
{
	f.y*=-1.0f;
	return f;
}


	//for(i=0;i<=nsamh;++i)
	//	for(j=-nsamh;j<=nsamh;++j)
__global__ void rotate2d_1(CPLX *outc, CPLX *bufc,int nsam, int nsamh, int nsam4, int nsamh4, 
				int ipad, int irad2, float dm0, float dm1, float dm3, float dm4)
{
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	int j=blockIdx.y*blockDim.y+threadIdx.y-nsamh;
	if(i>nsamh || j>nsamh) return;
	int ii,jj,itemp,l,m,ll,mm,id,id4;
	float x,y;
	
	ii=i+1;
	itemp=i*i+j*j;
	if(itemp<irad2)
	{
		jj=j+1;
		if(jj<1) jj+=nsam;
		id=ii+nsam/2*(jj-1);
		x=dm0*i+dm3*j;
		y=dm1*i+dm4*j;
				
		l=(x>=0.0f)?int(ipad*x+0.5f):int(ipad*x-0.5f);
		m=(y>=0.0f)?int(ipad*y+0.5f):int(ipad*y-0.5f);
		if(l>=0)
		{
			ll=l+1;
			mm=m+1;
			if(mm<1) mm+=nsam4;
			id4=ll+nsamh4*(mm-1);
			outc[id-1]=bufc[id4-1];
		}
		else
		{
			ll=-l+1;
			mm=-m+1;
			if(mm<1) mm+=nsam4;
			id4=ll+nsamh4*(mm-1);
			outc[id-1]=conjg(bufc[id4-1]);
		}
	}
}

void rotate2d(int nsam, int ipada, CPLX *spec, CPLX *speq, CPLX *outc, 
				float psi, CPLX *bufc)
{
	int ipad,nsam4,i,j,ii,jj,ib,id4;
	int l,m,ll,mm,id,nsamh,irad2,nsamh4,itemp;
	float x,y,dm[9],cpsi,spsi;
	
	ipad=abs(ipada);
	nsam4=ipad*nsam;
	nsamh=nsam/2;
	nsamh4=nsam4/2;
	irad2=(nsamh-1)*(nsamh-1);
	ib=nsam4*nsam4/2+1;
	
	cudaMemset((void *)outc,0,sizeof(float)*nsam*nsam);
	
	cpsi=cos(psi);
	spsi=sin(psi);
	
	dm[0]=cpsi;
	dm[1]=spsi;
	dm[3]=-spsi;
	dm[4]=cpsi;
	
	if(ipada<0) pad(nsam,ipad,(float *)spec,speq,(float *)bufc,&bufc[ib-1]);
	
	dim3 DimBlock(16,16);
	dim3 DimGrid((nsamh+1)/DimBlock.x+1,(2*nsamh+1)/DimBlock.y+1);
	rotate2d_1<<<DimGrid,DimBlock>>>(outc, bufc,nsam, nsamh, nsam4, nsamh4, ipad, irad2, 
												dm[0], dm[1], dm[3], dm[4]);
	cudaThreadSynchronize();
	
	return;
}



/*
void rotate2d(int nsam, int ipada, CPLX *spec, CPLX *speq, CPLX *outc, 
				float psi, CPLX *bufc)
{
	int ipad,nsam4,i,j,ii,jj,ib,id4;
	int l,m,ll,mm,id,nsamh,irad2,nsamh4,itemp;
	float x,y,dm[9],cpsi,spsi;
	
	ipad=abs(ipada);
	nsam4=ipad*nsam;
	nsamh=nsam/2;
	nsamh4=nsam4/2;
	irad2=(nsamh-1)*(nsamh-1);
	ib=nsam4*nsam4/2+1;
	
	memset((void *)outc,0,sizeof(float)*nsam*nsam);
	
	cpsi=cos(psi);
	spsi=sin(psi);
	
	dm[0]=cpsi;
	dm[1]=spsi;
	dm[3]=-spsi;
	dm[4]=cpsi;
	
	if(ipada<0) pad(nsam,ipad,(float *)spec,speq,(float *)bufc,&bufc[ib-1]);
	
	for(i=0;i<=nsamh;++i)
		for(j=-nsamh;j<=nsamh;++j)
		{
			ii=i+1;
			itemp=i*i+j*j;
			if(itemp<irad2)
			{
				jj=j+1;
				if(jj<1) jj+=nsam;
				id=ii+nsamh*(jj-1);
				x=dm[0]*i+dm[3]*j;
				y=dm[1]*i+dm[4]*j;
				
				l=(x>=0.0f)?int(ipad*x+0.5f):int(ipad*x-0.5f);
				m=(y>=0.0f)?int(ipad*y+0.5f):int(ipad*y-0.5f);
				if(l>=0)
				{
					ll=l+1;
					mm=m+1;
					if(mm<1) mm+=nsam4;
					id4=ll+nsamh4*(mm-1);
					outc[id-1]=bufc[id4-1];
				}
				else
				{
					ll=-l+1;
					mm=-m+1;
					if(mm<1) mm+=nsam4;
					id4=ll+nsamh4*(mm-1);
					outc[id-1]=conjg(bufc[id4-1]);
				}
			}
		}
	return;
}

*/





