#include "va04_gpu.h"
#include "calcfx_gpu.h"


//  STANDARD FORTRAN 66 (A VERIFIED PFORT SUBROUTINE)  - Powell minimisation
//  some changes were made to reduce diagnostic output and prevent occasional
//  crashes (Niko, 12. June 1998)
//  Calls CALCFX
//  Used in PREFINE, MAGREFINE, CTFREFINE.

void va04a(float *x, float *e, int &n, float &f, float &escale, 
	int iprint, int icon, int &maxit, float *xpar, 
	int &npar, int nsam, int &maxr1, int &maxr2, int *mask, 
	int nn1, CPLX *c3df, CPLX *c3ds, int &irad, 
	CPLX *outq, int npb, float *pbuf, CPLX *pbuq, float *shx, 
	float *shy, int ipad, float cs, float wl, float &wgh1, float &wgh2, 
	float &thetatr, CPLX *ctff, CPLX *ctfs, float *amag, float &rih, 
	float halfw, float &ri2, float &ri3, float &ri4, float *phi, float *theta, 
	float *psi, float &rmax1, float &rmax2, float &xstd, float *mbuf, 
	int *ilst, CPLX *datc, CPLX *datq, int &ibuf, float *b3dv, float *datd, 
	float *sinclut, int &ivflag, float &rbfact, float *outd, 
	CPLX *outc, CPLX *qbuc, CPLX *qbuq, float *rbuf, float *fsct, 
	float *dfmid1, float *dfmid2, float *angast, int &iewald, float tx, 
	float ty, float xm, float ym, float &sx, float &sy, float &sig2)
{
	float a=0.0, b=0.0, d=0.0;
	int i, j, k;
	float w[60], da=0.0, db=0.0, fa=0.0, dd=0.0, fb=0.0;
	float fc=0.0, dc=0.0, di=0.0, fi=0.0, dl=0.0;
	int jj;
	float fp;
	int is;
	float xs[10], aaa=0.0;
	int ind, jjj, jil, inn, ixp;
	float tmp, sum, dacc, dmag;
	int nfcc=0, icnt=0;
	float scer, dmax;
	int maxx=0;
	float ddmag, fkeep, fhold, ddmax;
	int iline, iterc, idirn, itone;
	float fprev;
	int isgrad=0;

	ddmag=0.1*escale;
	scer=0.05/escale;
	icnt=0;
	maxx=100*maxit;
	for(i=0;i<n;++i)
	{
		xs[i]=x[i];
	}

	jj=n*n+n;
	jjj=jj+n;
	k=n+1;
	nfcc=1;
	ind=1;
	inn=1;
	for(i=1;i<=n;++i)
		for(j=1;j<=n;++j)
		{
			w[k-1]=0.0f;
			if(i==j)
			{	
				w[k-1]=abs(e[i-1]);
				w[i-1]=escale;
			}
			k++;
		}

	iterc=1;
	isgrad=2;
	++icnt;

	if(icnt>maxx) goto L998;
	calcfx(nn1,n,x,f,xpar,npar,nsam,maxr1,maxr2,mask,
			c3df,c3ds,irad,outq,pbuf,pbuq,shx,
			shy,cs,wl,wgh1,wgh2,thetatr,ctff,ctfs,amag,
			rih,halfw,ri2,ri3,ri4,phi,theta,psi,rmax1,
			rmax2,xstd,mbuf,ilst,datc,datq,ibuf,b3dv,datd,
			sinclut,ivflag,rbfact,outd,outc,qbuc,qbuq
			,npb,ipad,rbuf,fsct,dfmid1,dfmid2,
			angast,iewald,tx,ty,xm,ym,sx,sy,sig2);
	fkeep=abs(f)+abs(f);
L5:
	itone=1;
	fp=f;
	sum=0.0;
	ixp=jj;

	for(i=1;i<=n;++i)
	{
		++ixp;
		w[ixp-1]=x[i-1];
	}

	idirn=n+1;
	iline=1;
L7:
	dmax=w[iline-1];
	dacc=dmax*scer;
	dmag=min(ddmag,0.1*dmax);
	dmag=max(dmag,20.0*dacc);
	ddmax=dmag*10.0;

	switch(itone)
	{
		case 1: goto L70;
		case 2: goto L70;
		case 3: goto L71;
	}
L70:
	dl=0.0f;
	d=dmag;
	fprev=f;
	is=5;
	fa=f;
	da=dl;
L8:
	dd=d-dl;
	dl=d;
L58:
	k=idirn;

	for(i=1;i<=n;++i)
	{
		x[i-1]+=dd*w[k-1];
		++k;
	}

	++icnt;

	if(icnt>maxx)	goto L998;
	
	calcfx(nn1,n,x,f,xpar,npar,nsam,maxr1,maxr2,mask,
			c3df,c3ds,irad,outq,pbuf,pbuq,shx,
			shy,cs,wl,wgh1,wgh2,thetatr,ctff,ctfs,amag,
			rih,halfw,ri2,ri3,ri4,phi,theta,psi,rmax1,
			rmax2,xstd,mbuf,ilst,datc,datq,ibuf,b3dv,datd,
			sinclut,ivflag,rbfact,outd,outc,qbuc,qbuq
			,npb,ipad,rbuf,fsct,dfmid1,dfmid2,
			angast,iewald,tx,ty,xm,ym,sx,sy,sig2);
			
	++nfcc;

	switch(is)
	{
		case 1:  goto L10;
		case 2:  goto L11;
		case 3:  goto L12;
		case 4:  goto L13;
		case 5:  goto L14;
		case 6:  goto L96;
	}

L14:
	if((f-fa)<0.0f) goto L15;
	else if((f-fa)==0.0f) goto L16;
   else goto L24;

L16:
  if((abs(d)-dmax)<=0.0f) goto L17;
	else goto L18;

L17:
	d+=d;
	goto L8;
L18:
	//printf("   50HPOWELL MIN: MAXIMUM CHANGE DOES NOT ALTER FUNCTION\n");
	goto L20;
L15:
	fb=f;
	db=d;
	goto L21;
L24:
	fb=fa;
	db=da;
	fa=f;
	da=d;
L21:
	switch(isgrad)
	{
		case 1: goto L83;
		case 2: goto L23;
	}
L23:
	d=db+db-da;
	is=1;
	goto L8;
L83:
	d=0.5*(da+db-(fa-fb)/(da-db));
	is=4;
	if((da-d)*(d-db)>=0.0)goto L8;
L25:
	is=1;
	if((abs(d-db)-ddmax)<=0.0) goto L8;
L26:
	if((db-da)<0.0) d=db-abs(ddmax);
	else d=db+abs(ddmax);
	is=1;
	ddmax+=ddmax;
	ddmag+=ddmag;
	if((ddmax-dmax)<=0.0) goto L8;
	ddmax = dmax;
	goto L8;
L13:
	if((f-fa)>=0.0) goto L23;
L28:
	fc=fb;
	dc=db;
L29:
	fb=f;
	db=d;
	goto L30;
L12:
	if((f-fb)<=0.0) goto L28;
	fa=f;
	da=d;
	goto L30;
L11:
    if((f-fb)>=0.0)goto L10;

	fa=fb;
	da=db;
	goto L29;
L71:
	dl=1.0f;
	ddmax=5.0;
	fa=fp;
	da=-1.0;
	fb=fhold;
	db=0.0;
	d=1.0;
L10:
	fc=f;
	dc=d;
L30:
	a=(db-dc)*(fa-fc);
	b=(dc-da)*(fb-fc);
	if((a+b)*(da-dc)>0.0)goto L34;

	fa=fb;
	da=db;
	fb=fc;
	db=dc;
	goto L26;
L34:
	d=0.5*(a*(db+dc)+b*(da+dc))/(a+b);
	di=db;
	fi=fb;
	if((fb-fc)<=0.0) goto L44;

	di=dc;
	fi=fc;
L44:
	switch (itone) 
	{
		case 1: goto L86;
		case 2: goto L86;
		case 3: goto L85;
	}
L85:
	itone=2;
   goto L45;
L86:
	if((abs(d-di)-dacc)<=0.0) goto L41;
	else goto L93;
L93:
	if((abs(d-di)-0.03*abs(d))<=0.0) goto L41;
	else goto L45;
L45:
	if((da-dc)*(dc-d)>=0.0) goto L46;
	else goto L47;
L46:
	fa=fb;
	da=db;
	fb=fc;
	db=dc;
	goto L25;
L47:
	is=2;
	if((db-d)*(d-dc)>=0.0) goto L8;

	is=3;
	goto L8;
L41:
	f=fi;
	d=di-dl;
	dd=(dc-db)*(dc-da)*(da-db)/(a+b);
	if(dd<0.0) dd=1e-10;
	dd=sqrt(dd);
	for(i=1;i<=n;++i)
	{
		x[i-1]+=d*w[idirn-1];
		w[idirn-1]=dd*w[idirn-1];
		++idirn;
	}
	if(dd==0.0) dd=1e-10;
	w[iline-1]/=dd;
	++iline;
	if((iprint-1)!=0)goto L51;
L50:
	switch (iprint) 
	{
		case 1:  goto L51;
		case 2:  goto L53;
	}
L51:
	switch (itone) 
	{
		case 1:  goto L55;
		case 2:  goto L38;
	}
L55:
	if((fprev-f-sum)<0.0) goto L94;

	sum=fprev-f;
	jil=iline;
L94:
	if((idirn-jj)<=0) goto L7;
	else goto L84;
L84:
	switch (ind) 
	{
		case 1:  goto L92;
		case 2:  goto L72;
	}
L92:
	fhold=f;
	is=6;
	ixp=jj;
	for(i=1;i<=n;++i)
	{
		++ixp;
		w[ixp-1]=x[i-1]-w[ixp-1];
	}
	dd=1.0f;
	goto L58;
L96:
	switch (ind) 
	{
		case 1:  goto L112;
		case 2:  goto L87;
	}
L112:
	if((fp-f)<=0.0) goto L37;

	d=2.0*(fp+f-2.0*fhold)/pow(fp-f,2);
	if((d*pow(fp-fhold-sum,2)-sum)>=0.0f) goto L37;
L87:
	j=jil*n+1;
	if((j-jj)>0) goto L61;

	for(i=j;i<=jj;++i)
	{
		k=i-n;
		w[k-1]=w[i-1];
	}
	for(i=jil;i<=n;++i)
	{
		w[i-2]=w[i-1];
	}
L61:
	idirn-=n;
	itone=3;
	k=idirn;
	ixp=jj;
	aaa=0.0;
	for(i=1;i<=n;++i)
	{
		++ixp;
		w[k-1]=w[ixp-1];
		if((aaa-abs(w[k-1]/e[i-1]))>=0.0) goto L67;

		aaa=abs(w[k-1]/e[i-1]);
L67:
		++k;
	}
	ddmag=1.0;
	if(aaa==0.0) aaa=1e-10;
	w[n-1]=escale/aaa;
	iline=n;
	goto L7;
L37:
	ixp=jj;
	aaa=0.0;
	f=fhold;

	for(i=1;i<=n;++i)
	{
		++ixp;
		x[i-1]-=w[ixp-1];
		if((aaa*abs(e[i-1])-abs(w[ixp-1]))>=0.0) continue;

		aaa=abs(w[ixp-1]/e[i-1]);
	}
	goto L72;
L38:
	aaa*=di+1.0;
	switch(ind)
	{
		case 1: goto L72;
		case 2: goto L106;
	}
L72:
	if((iprint-2)>=0) goto L50;
L53:
	switch (ind) 
	{
		case 1: goto L109;
		case 2: goto L88;
	}
L109:
	if((aaa-0.1)>0.0)goto L76;

	switch (icon)
	{
		case 1: goto L20;
		case 2: goto L116;
	}
L116:
	ind=2;
	switch (inn)
	{
		case 1: goto L100;
		case 2: goto L101;
	}

L100:
	inn=2;
	k=jjj;

	for(i=1;i<=n;++i)
	{
		++k;
		w[k-1]=x[i-1];
		x[i-1]+=e[i-1]*10.0;
	}

	fkeep=f;
	++icnt;
	if(icnt>maxx) goto L998;

	calcfx(nn1,n,x,f,xpar,npar,nsam,maxr1,maxr2,mask,
			c3df,c3ds,irad,outq,pbuf,pbuq,shx,
			shy,cs,wl,wgh1,wgh2,thetatr,ctff,ctfs,amag,
			rih,halfw,ri2,ri3,ri4,phi,theta,psi,rmax1,
			rmax2,xstd,mbuf,ilst,datc,datq,ibuf,b3dv,datd,
			sinclut,ivflag,rbfact,outd,outc,qbuc,qbuq
			,npb,ipad,rbuf,fsct,dfmid1,dfmid2,
			angast,iewald,tx,ty,xm,ym,sx,sy,sig2);

	++nfcc;
	ddmag=0.0f;
	goto L108;
L76:
	if((f-fp)<0.0f) goto L35;
L78:
	goto L20;
L88:
	ind=1;
L35:
	tmp=fp-f;
	if(tmp>0.0)ddmag=sqrt(tmp)*0.4;
	else ddmag=0.0;
	isgrad=1;
L108:
	++iterc;
	if((iterc-maxit)<=0) goto L5;
	else goto L81;

L81:

	if((f-fkeep)<=0.0) goto L20;

	f=fkeep;
	for(i=1;i<=n;++i)
	{
		++jjj;
		x[i-1]=w[jjj-1];
	}
	goto L20;
L101:
	jil=1;
	fp=fkeep;
	if((f-fkeep)<0.0)goto L105;
	else if ((f-fkeep)==0) goto L78;

	jil=2;
	fp=f;
	f=fkeep;
	L105:
	ixp=jj;
	for(i=1;i<=n;++i)
	{
		++ixp;
		k=ixp+n;
		switch(jil)
		{
			case 1: goto L114;
			case 2: goto L115;
		}
L114:
		w[ixp-1]=w[k-1];
		continue;
L115:
		w[ixp-1]=x[i-1];
		x[i-1]=w[k-1];
	}
	
	jil=2;
	goto L92;
L106:
	if((aaa-0.1)>0.0) goto L107;
L20:
	return;
L107:
	inn=1;
	goto L35;
L998:
	for(i=1;i<=n;++i)
	{
		x[i-1]=xs[i-1];
	}
			
	calcfx(nn1,n,x,f,xpar,npar,nsam,maxr1,maxr2,mask,
			c3df,c3ds,irad,outq,pbuf,pbuq,shx,
			shy,cs,wl,wgh1,wgh2,thetatr,ctff,ctfs,amag,
			rih,halfw,ri2,ri3,ri4,phi,theta,psi,rmax1,
			rmax2,xstd,mbuf,ilst,datc,datq,ibuf,b3dv,datd,
			sinclut,ivflag,rbfact,outd,outc,qbuc,qbuq
			,npb,ipad,rbuf,fsct,dfmid1,dfmid2,
			angast,iewald,tx,ty,xm,ym,sx,sy,sig2);
			
	//printf("VA04A ENDLESS LOOP SAFETY CATCH: ICNT = %d\n", icnt);
	return;
}
